program oddface_pig2;
uses
  {$IFDEF UNIX}{$IFDEF UseCThreads}
  cthreads,
  {$ENDIF}{$ENDIF}
  Classes,
  uConstantesSimSEE, uInicioYFinal, uActores, uDataSetGenerico,
  uoddface_pig2,
  usimplex, urosx,
  u_updownload, uempaquetar, uRobotHttpPost, httpsend,
  sysutils;

var
 idEjecutor: string;
 idProblema: integer;
 idNodo: integer;
 problema: TPIG_Problema;
 res: integer;



begin
  SetLength(TrueBoolStrs,1);
  SetLength(FalseBoolStrs,1);
  TrueBoolStrs[0]:='1';
  FalseBoolStrs[0]:='0';

  if ParamCount < 2 then
  begin
    writeln( 'Debe pasar por lo menos dos parametros para identificacion del Ejecutor y el Problema' );
    exit;
  end;
  idEjecutor:= paramStr( 1 );

  idProblema:= StrToInt(ParamStr( 2 ) );

  if ParamCount < 3 then
    idNodo:= 0 // el cluster
  else
    idNodo:= StrToInt( paramStr( 3 ) );


  tmp_rundir:= CrearDirectorioTemporal( idEjecutor );

  if tmp_rundir <> '' then
    limpiarCarpeta( tmp_rundir, '*.*' );

  writeln('Cambiando el directorio a : ',tmp_rundir );
  chdir( tmp_rundir );

  problema:= TPIG_Problema.CreateFromDB( idProblema, StrToInt(idEjecutor), tmp_rundir );
  if problema =  nil then
    raise Exception.Create( 'No fue posible crear el problema.' );

  randomize;
  res:= problema.Explorar;
  problema.Free;

  writeln( 'Cantidad de evaluaciones realizadas: ', res );

  if tmp_rundir <> '' then
  begin
    limpiarCarpeta( tmp_rundir, '*.*' );
    removeDir( tmp_rundir );
  end;
end.

