{xDEFINE INTERFACE_ADME}

unit SimSEEEditMain;

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

interface

uses
{$IFDEF FPC-LCL}
  LResources,
  EditBtn,
{$ENDIF}

{$IFDEF FPC-LCL}
 ueditarfichafuentetiempo, ufuentetiempo,
 ueditarfichafuentesinusoide, ufuentesinusoide,
 ueditarfichafuentemaxmin, ufuentemaxmin, uEditarTGTer_Combinado,
  uEditarTMercadoSpot_postizado, uEditarFichaGTer_combinado,
    uEditarFichaMercadoSpot_postizado, uEditarFichaMercadoSpot_postizado_Fuentes,
 {$IFDEF CON_CALIBRADOR}
  ucalibrador,
{$ENDIF}
 {$ENDIF}

{$IFDEF FPC}
  FileUtil,
{$ENDIF}
  Windows,  SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, ComCtrls, ExtCtrls, Grids, Buttons,
  xmatdefs, ufechas, utilidades, utrazosxy, ShellApi, uConstantesSimSEE,
  uFormEditarOpciones, uAuxiliares, uBaseFormularios,
  uverdoc, uversiones,
  usalasdejuego,
  usalasdejuegoParaEditor,
  uListaMantenimientos,

  uEditarFichaUnidades,

  ucosa, uActorNodal, uActores, uGTer, ugter_basico,
  ugter_arranqueparada, ugter_onoffporpaso, ugter_onoffporposte, ugter_combinado,
{$IFDEF COMBUSTIBLES}
  ugter_onoffporposteV2,
  uEditarTGTerV2,
  ugter_onoffporpasoV2,
  ugter_arranqueparadaV2,
  ugter_combinadoV2,
{$ENDIF}
  unodos, uDemandas,
  udemandas01, uDemandaAnioBaseEIndices,
  uDemandaDetallada, uArcos, uCombustible,
  uHidroConEmbalse,
  uHidroConBombeo,
  uGeneradores,
  uCosaConNombre, uHidroDePasada, uMercadoSpot, uMercadoSpot_postizado,
  uParqueEolico,
  uParqueEolico_vxy,
  ugter_basico_TRep, ugter_basico_PyCVariable, ucontratomodalidaddevolucion,
  uComercioInternacional, uMercadoSpotConDetalleHorarioSemanal,
  ugter_onoffporpaso_conrestricciones, uHidroConEmbalseBinacional,
  uEditorSimRes3Main, uOpcionesSimSEEEdit,
  uBaseEditoresCosasConNombre, uEditarTNodo, uEditarTContratoModalidadDevolucion,
  uEditarTArco, uEditarTDemanda01, uEditarTDemandaAnioBaseEIndices, uEditarTDemandaDetallada,
  uEditarTCombustible,
  uEditarTGTer, uEditarTGTer_ArranqueParada, uEditarTGTer_Basico_TRep, uEditarTGTer_Basico_PyCVariable,
  uEditarTGTer_OnOffPorPaso_ConRestricciones,
  uEditarTHidroConEmbalse,
  uEditarTHidroConBombeo,
  uEditarTHidroConEmbalseBinacional, uEditarTHidroDePasada,
  uEditarTBaseMercadoSpot,
  uEditarTParqueEolico,
  uEditarTParqueEolico_vxy,
  uManejadoresDeMonitores,
  uReferenciaMonitor, uReferenciaMonitorConsola, uReferenciaMonitorGraficoSimple,
  uReferenciaMonArchivo, uReferenciaMonHistograma, uReferenciaMonSimRes,
  uBaseAltasMonitores, uAltaMonitorConsola, uAltaMonitorGrafico, uAltaMonArchivo,
  uAltaMonHistograma, uAltaMonSimRes,
  uFuentesAleatorias,
  uFuenteConstante, uFuenteUniforme, uFuenteGaussiana, uFuenteWeibull,
  uFuenteSintetizador, uFuenteCombinacion, uFuenteProducto,
  uEditarFuentesSimples, uEditarFuenteSintetizador,
  uEditarFichaFuenteUniforme, uEditarFichaFuenteGaussiana, uEditarFichaFuenteConstante,
  uEditarFichaFuenteWeibull, uEditarFichaFuenteCombinacion, uEditarFichaFuenteProducto,
  uBaseEditoresFichas, uEditarFichaGTer_Basico, uEditarFichaGTer_ArranqueParada,
  uEditarFichaGTer_OnOffPorPaso, uEditarFichaGTer_OnOffPorPoste,
{$IFDEF COMBUSTIBLES}
  uEditarFichaGTer_OnOffPorPosteV2,
  uEditarFichaGTer_OnOffPorPasoV2,
  uEditarFichaGTer_ArranqueParadaV2,
  uEditarFichaGTer_combinadoV2,
{$ENDIF}
  uEditarFichaDemanda01, uEditarFichaHidroConEmbalse,
  uEditarFichaHidroConBombeo,
  uEditarFichaHidroDePasada,
  uEditarFichaArco, uEditarFichaMercadoSpot, uEditarFichaGTer_Basico_TRep, uEditarFichaGTer_Basico_PyCVariable,
  uEditarFichaContratoModalidadDevolucion, uEditarFichaMercadoSpotConDetalleHorario,
  uEditarFichaGTer_OnOffPorPaso_ConRestricciones,
  uEditarFichaHidroConEmbalseBinacional,
{$IFDEF FPC-LCL}
  uEditarFichaCombustible,
{$ENDIF}
  uInfoTabs, uFormSelectTipo, uInfoCosa, uFormExportar,
  uSimplex, uMipSimplex, uEstados, uEditarEnganches,
  uManejadorListadoEditores,
  uComponerCFs;

resourcestring
  strTabDemandas = 'Demandas';
  strTabGeneradoresTermicos = 'Térmicas';
  strTabRed = 'Red';
  strTabGeneradoresHidraulicos = 'Hidráulicas';
  strTabEolica = 'Eólicas';
  strTabComercioInternacional = 'Internacional';
  strTabCombustibles = 'Combustible';
  rsActor = 'Actor';
  rsTipoDeActor = 'Tipo de actor';
  rsFecha = 'Fecha';
  rsUnidades = 'Unidades';
  rsInformacioNAdicional = 'Información adicional';
  rsFechaDeMuerte = 'Fecha de muerte';
  rsFechaDeNacimiento = 'Fecha de nacimiento';
  rsPosteN = 'Poste Nº';
  rsDuracioN = 'Duración';
  rsFuente = 'Fuente';
  rsTipoDeFuente = 'Tipo de fuente';
  rsTipoDeCombustible = 'Tipo de combustible';
  rsPeriodicaQ = 'Periódica?';
  rsMonitor = 'Monitor';
  rsTipo = 'Tipo';
  rsSeleccioneUnGenerador = 'Seleccione un generador';

  exFormularioEdicionParaClase = 'Formulario de edición no registrado para la clase ';
  exEditorNoRegistradoClase = 'Editor no registrado para la clase ';
  exTipoActorDesconocido = 'Tipo de actor desconocido: ';
  exNoFuePosibleLeerSala = 'No fue posible leer la sala.';

  mesNoSePuedeEliminarActor = 'No se puede eliminar el actor ';
  mesExisteReferenciaAEl = ' pues existe una referencia a el.';
  mesElimineLasReferenciasVuelvaIntentarlo = 'Elimine las referencias y vuelva a intentarlo.';
  mesConfirmaEliminarActor = '¿Confirma que desea eliminar el actor ';
  mesEliminaNodoActoresReferenciasVacias = 'Si elimina el nodo seleccionado '
    + 'los siguientes actores quedaran con referencias vacias:';
  mesConfirmarEliminacion = 'Confirmar eliminación';
  mesConfirmaEliminarNodo = '¿Confirma que desea eliminar el nodo "';
  mesElActor = 'El actor ';
  mesReferenciasSinResolverResuelvalas = ' tiene referencias sin resolver. Resuelvalas para poder continuar.';
  mesLaFuenteAleatoria = 'La fuente aleatoria ';
  mesErrorImportandoActor = 'Se encontro el siguiente error importando el actor:';
  mesArchivoAbiertoONoExiste = 'Puede ser que el archivo se encuentre abierto o no exista.';
  mesNoSePuedeEliminarFuenteReferencia = 'No se puede eliminar la fuente pues existe una referencia a ella. ';
  mesNoSePuedeEliminarCombustibleReferencia = 'No se puede eliminar el combustible pues existe una referencia a el. ';
  mesConfirmaDeseaEliminarFuentes = '¿Confirma que desea eliminar la fuente "';
  mesConfirmaDeseaEliminarCombustible = '¿Confirma que desea eliminar el combustible "';
  mesSimSEEEdit = 'SimSEEEdit';
  mesNoSeEncuentraArchivoMonitores = 'No se encuentra el archivo de monitores ';
  mesNoSeEncuentraSalaDeJuego = 'No se encuentra el archivo de sala de juego ';
  mesMonitoresNoGuardadosGuardarCambios = 'Los Monitores no se han guardado. ¿Desea guardar los cambios?';
  mesSalaNoGuardadaGuardarCambios = 'La sala no se ha guardado. ¿Desea guardar los cambios?';
  mesError = 'Error: ';
  mesElArchivo = 'El archivo ';
  mesNoExiste = ' no existe!';
  mesNoSePuedeEliminarLaFichaDeUnidades = 'No se puede eliminar la ficha de unidades pues es la '
    +'única que tiene el actor. Agregue otra y vuelva a intentarlo.';
  mesConfirmaEliminarFichaUnidadesActor = '¿Confirma que desea eliminar la ficha de unidades del actor "';
  mesConfirmaEliminarMonitor = '¿Confirma que desea eliminar el monitor "';
  mesMonitorXDefectoCreadoRemplazarlo = 'El monitor por defecto ya fue creado. ¿Desea reemplazarlo?';
  mesRemplazarMonitorSimRes3 = 'Reemplazar monitor SimRes3';
  mesValorIntroducidoDebeNum = 'El valor introducido debe ser numérico';
  mesArchivoSalaContieneErrores = 'El archivo de sala seleccionado contiene errores.';
  mesSeLogroCargarSalaConProblemas = ' Se logró cargar la sala, sin embargo '
    +'hubieron algunos problemas, revise el Memo de Advertencias para mas información.';
  mesAntesDeGuardarAsegureseContieneTodaInfo = 'Antes de guardar la sala '
    +'asegurese que contiene toda la información que usted desea.';
  mesHorizontesSimulacionNoValidos = 'Los horizontes de simulación u optimización no son válidos.';
  mesGuardarCambiosSalaParaContinuar = 'Debe guardar los cambios realizados a la sala para continuar.'
    +'¿Desea hacerlo ahora?';
  mesSeDebeCumplirRelacionHorizontes = 'Se debe cumplir IniOpt <= IniSim <= FinSim <= FinOpt';
  mesGuardarCambiosMonitoresParaContinuar = 'Debe guardar los cambios realizados a los monitores'
    +'para continuar. ¿Desea hacerlo ahora?';
  mesSeleccionarArchivoBin = 'Debe seleccionar un archivo CF.bin';
  rsArchivosBinariosDeCostosFuturos = 'Archivos Binarios de Costos Futuros';
  rsTodosLosArchivos = 'Todos los Archivos';
  mesGuardarMantenimientos = 'Los mantenimientos han sido guardados';

const
  NDivsAnioPMantenimiento = 53;
  separadorDeLineas = '|';



type

  { TFSimSEEEdit }

  TFSimSEEEdit = class(TBaseFormularios)
    BAgregarCombustible: TButton;
    bEliminarActorV2: TBitBtn;
    bClonarActorV2: TBitBtn;
    BAyudaEnganchar: TButton;
    bAgregarActorV2: TBitBtn;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    btVaciarCFAux: TButton;
    bt_VaciarCFEnganche: TButton;
    btVerMantenimientos: TButton;
    gbEditorActores: TGroupBox;
    gbActores: TGroupBox;
    LabelEnganchar: TLabel;
    lbActores: TListBox;
    MainMenu1: TMainMenu;
    MArchivo: TMenuItem;
    miComponerCFs: TMenuItem;
    MNuevo: TMenuItem;
    MAbrir: TMenuItem;
    N1: TMenuItem;
    MGuardar: TMenuItem;
    MGuardarComo: TMenuItem;
    N2: TMenuItem;
    MSalir: TMenuItem;
    DCargarSala: TOpenDialog;
    DSalvarSala: TSaveDialog;
    Panel6: TPanel;
    pBotoneraActoresV2: TPanel;
    PCEditMain: TPageControl;
    RBElegirSala: TRadioButton;
    RBElegirCF: TRadioButton;
    sbEditorActores: TScrollBox;
    sgCombustible: TStringGrid;
    TSCombustible: TTabSheet;
    TCActoresV2: TTabControl;
    TSGlobales: TTabSheet;
    TSActores: TTabSheet;
    TCActores: TTabControl;
    PActores: TPanel;
    TSFuentes: TTabSheet;
    TSEstado: TTabSheet;
    TSSimulador: TTabSheet;
    TSMonitores: TTabSheet;
    BAgregarMonitor: TButton;
    sgMonitores: TStringGrid;
    MAyuda: TMenuItem;
    MManual: TMenuItem;
    DSalvarManejadorMonitores: TSaveDialog;
    MHerramientas: TMenuItem;
    MImportar: TMenuItem;
    MExportar: TMenuItem;
    sgFuentes: TStringGrid;
    BAgregarFuente: TButton;
    DCargarManejadorMonitores: TOpenDialog;
    MMonitores: TMenuItem;
    MCargarMonitores: TMenuItem;
    N4: TMenuItem;
    MGuardarMonitores: TMenuItem;
    MGuardarMonitoresComo: TMenuItem;
    BSimular: TButton;
    DImportarActor: TOpenDialog;
    MOpciones: TMenuItem;
    btAyudaFuentes: TButton;
    btAyudaEstados: TButton;
    btAyudaMonitores: TButton;
    gbHorizTiempo: TGroupBox;
    LFechaIni: TLabel;
    {$IFNDEF FPC-LCL}
      DTPFechaIniSim: TDateTimePicker;
      DTPFechaFinSim: TDateTimePicker;
    {$ELSE}
      DTPFechaIniSim: TDateEdit;
      DTPFechaFinSim: TDateEdit;
    {$ENDIF}

    LFechaFin: TLabel;
    gbPasoTiempo: TGroupBox;
    LNPostes: TLabel;
    IntNPostes: TEdit;
    CBPostesMonotonos: TCheckBox;
    sgPostes: TStringGrid;
    btAyudaGlobales: TButton;
    LDurPaso: TLabel;
    EDurPaso: TEdit;
    LNPasosSim: TLabel;
    ENPasosSim: TEdit;
    ODO1: TMenuItem;
    gbVarSim_: TGroupBox;
    LNCronicasSim: TLabel;
    ENCronicasSim: TEdit;
    CBObligar_Disp1: TCheckBox;
    gbVarOpt: TGroupBox;
    EtAct: TEdit;
    ENCronicasOpt: TEdit;
    LNCronicasOpt: TLabel;
    LtAct: TLabel;
    CBSorteos: TCheckBox;
    btAyudaSimulador: TButton;
    PanelInferiorPrincipal: TPanel;
    gbAdvertencias: TGroupBox;
    MemoWarnings: TMemo;
    Splitter1: TSplitter;
    Splitter2: TSplitter;
    gbDesc: TGroupBox;
    MemoDesc: TMemo;
    GBInicializarCF: TGroupBox;
    RGLlenarUltimoFrame: TRadioGroup;
    EArchivoCF: TEdit;
    BBuscarArchivoCF: TButton;
    CBEstabilizarFrameInicial: TCheckBox;
    ODCF: TOpenDialog;
    ENPasosOpt: TEdit;
    LNPasosOpt: TLabel;
    LSim: TLabel;
    LOpt: TLabel;
    LFIniOpt: TLabel;
    LFFinOpt: TLabel;
    {$IFNDEF FPC}
      DTPFechaIniOpt: TDateTimePicker;
      DTPFechaFinOpt: TDateTimePicker;
    {$ELSE}
      DTPFechaIniOpt: TDateEdit;
      DTPFechaFinOpt: TDateEdit;
    {$ENDIF}

    BEnganches: TButton;
    MGenerarResumenTermico: TMenuItem;
    Panel1: TPanel;
    BGenerarResumenTermico: TButton;
    BImportar: TButton;
    BExportar: TButton;
    BAgregarActor: TButton;
    Panel2: TPanel;
    btAyudaActores_listaespecifica: TButton;
    Panel3: TPanel;
    sgActores: TStringGrid;
    TSAyudaSolaperoPrincipal: TTabSheet;
    MEditorSimRes3: TMenuItem;
    TSMantenimientos: TTabSheet;
    sgMantenimientos: TStringGrid;
    BAgregarFichaUnidades: TButton;
    BCrearMonitorSimRes3PDefecto: TButton;
    N3: TMenuItem;
    MCrearMonitorSimResPorDefecto: TMenuItem;
    lMaxNItersOpt: TLabel;
    eMaxNItersOpt: TEdit;
    eMaxNItersSim: TEdit;
    lMaxNItersSim: TLabel;
    MActualizar: TMenuItem;
    GroupBox1: TGroupBox;
    eArchiCFaux: TEdit;
    Button1: TButton;
    btBuscarCFaux: TButton;
    ddd1: TMenuItem;
    TSActoresV2: TTabSheet;
    pEdicionActoresV2: TPanel;
    Button6: TButton;
    procedure BAyudaEngancharClick(Sender: TObject);
    procedure btVerMantenimientosClick(Sender: TObject);
    procedure btVaciarCFAuxClick(Sender: TObject);
    procedure bt_VaciarCFEngancheClick(Sender: TObject);
    procedure eArchiCFauxChange(Sender: TObject);
    procedure EArchivoCFChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure EditTamTablaExit(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure miComponerCFsClick(Sender: TObject);
    procedure MNuevoClick(Sender: TObject);
    procedure MAbrirClick(Sender: TObject);
    procedure MGuardarComoClick(Sender: TObject);
    procedure MGuardarClick(Sender: TObject);
    procedure MSalirClick(Sender: TObject);
    procedure RBElegirCFChange(Sender: TObject);
    procedure RBElegirSalaChange(Sender: TObject);
    procedure sgPostesValidarCambio(Sender: TObject);
    procedure TCActoresChange(Sender: TObject);
    procedure BAgregarActorClick(Sender: TObject);
    procedure sgActoresDrawCell(Sender: TObject; ACol, ARow: Integer; Rect: TRect;
      State: TGridDrawState);
    procedure sgActoresMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer);
    procedure sgActoresMouseMove(Sender: TObject; Shift: TShiftState; X, Y: integer);
    procedure sgActoresMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer);
    procedure EditNCronicasSimExit(Sender: TObject);
    procedure BSimularClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
    procedure sgMonitoresDrawCell(Sender: TObject; ACol, ARow: Integer; Rect: TRect;
      State: TGridDrawState);
    procedure sgMonitoresMouseMove(Sender: TObject; Shift: TShiftState; X, Y: integer);
    procedure sgMonitoresMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: integer);
    procedure sgMonitoresMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer);
    procedure BAgregarMonitorClick(Sender: TObject);
    procedure recalcNumeroPasos(Sender: TObject);
    procedure MManualClick(Sender: TObject);
    procedure CBSorteosClick(Sender: TObject);
    procedure EtActExit(Sender: TObject);
    procedure CBObligar_Disp1Click(Sender: TObject);
    procedure EditNCronicasOptExit(Sender: TObject);
    procedure DTPEnter(Sender: TObject);
    procedure MExportarClick(Sender: TObject);
    procedure MImportarClick(Sender: TObject);
    procedure PCEditMainChange(Sender: TObject);
    procedure sgMantenimientosDrawCell(Sender: TObject; ACol, ARow: Integer; Rect: TRect;
      State: TGridDrawState);
    procedure sgMantenimientosMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: integer);
    procedure sgFuentesMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer);
    procedure sgFuentesMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure sgFuentesDrawCell(Sender: TObject; ACol, ARow: Integer; Rect: TRect;
      State: TGridDrawState);
    procedure sgFuentesMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState;
      X, Y: integer);
    procedure sgCombustibleMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer);
    procedure sgCombustibleMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure sgCombustibleDrawCell(Sender: TObject; ACol, ARow: Integer; Rect: TRect;
      State: TGridDrawState);
    procedure sgCombustibleMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState;
      X, Y: integer);
    procedure BAgregarFuenteClick(Sender: TObject);
    procedure BAgregarCombustibleClick(Sender: TObject);
    procedure MCargarMonitoresClick(Sender: TObject);
    procedure MGuardarMonitoresClick(Sender: TObject);
    procedure MGuardarMonitoresComoClick(Sender: TObject);
    procedure BImportarClick(Sender: TObject);
    procedure BExportarClick(Sender: TObject);
    procedure MOpcionesClick(Sender: TObject);
    procedure CBPostesMonotonosClick(Sender: TObject);
    procedure MemoDescEnter(Sender: TObject);
    procedure MemoDescExit(Sender: TObject);
    procedure btAyudaSimuladorClick(Sender: TObject);
    procedure btAyudaGlobalesClick(Sender: TObject);
    procedure btAyudaFuentesClick(Sender: TObject);
    procedure btAyudaActores_listaespecificaClick(Sender: TObject);
    procedure btAyudaMantenimientosClick(Sender: TObject);
    procedure btAyudaEstadosClick(Sender: TObject);
    procedure btAyudaMonitoresClick(Sender: TObject);
    procedure ODO1Click(Sender: TObject);
    procedure CBEstabilizarFrameInicialClick(Sender: TObject);
    procedure RGLlenarUltimoFrameClick(Sender: TObject);
    procedure BBuscarArchivoCFClick(Sender: TObject);
    procedure EArchivoCFExit(Sender: TObject);
    { procedure DTPFechaIniOptChange(Sender: TObject);
      procedure DTPFechaIniSimChange(Sender: TObject);
      procedure DTPFechaFinSimChange(Sender: TObject);
      procedure DTPFechaFinOptChange(Sender: TObject); }
    procedure BEnganchesClick(Sender: TObject);
    procedure GenerarResumenTermico(Sender: TObject);
    procedure MEditorSimRes3Click(Sender: TObject);
    procedure sgMantenimientosMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure sgMantenimientosMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: integer);
    procedure BAgregarFichaUnidadesClick(Sender: TObject);
    procedure sgMantenimientosValidarCambio(Sender: TObject);
    procedure sgMantenimientosGetEditText(Sender: TObject; ACol, ARow: integer;
      var Value: string);
    procedure sgMantenimientosKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure EditEnter(Sender: TObject);
    procedure BCrearMonitorSimRes3PDefectoClick(Sender: TObject);
    procedure MCrearMonitorSimResPorDefectoClick(Sender: TObject);
    procedure eMaxNItersOptExit(Sender: TObject);
    procedure eMaxNItersSimExit(Sender: TObject);
    procedure DTPFechaIniSimChange(Sender: TObject);
    procedure DTPFechaFinSimChange(Sender: TObject);
    procedure DTPFechaIniOptChange(Sender: TObject);
    procedure DTPFechaFinOptChange(Sender: TObject);
    procedure sgPostesKeyDown(Sender: TObject; var Key: word; Shift: TShiftState);
    procedure MActualizarClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure btBuscarCFauxClick(Sender: TObject);
    procedure ddd1Click(Sender: TObject);
  private
    archiEditorSimRes3: string;

    hid_ActoresListaEspecifica: string;
    guardadoMonitores: Boolean;
    TiposColActores, TiposColMonitores, TiposColMantenimientos, TiposColFuentes, TiposColCombustibles: TDAOfTTipoColumna;
    monitoresEnabled: TDAOfBoolean;
    // Las listas de los actores que muestra el listado
    ListasDeActoresTabs: array of TListaDeCosasConNombre;

    listaMantenimientos: TListaMantenimientos;

    nErroresCargando: Integer;

    observadorCambiosEditoresActores: TObserverCambioDatosEnHijoDeBaseFormularios;
    manejadorListadoEditores: TManejadorListadoEditores;

    // Registra los actores conocidos con sus formularios de alta y sus editores
    procedure registrarActores;
    // Registra los monitores conocidos con sus formularios de alta y edicion
    procedure registrarMonitores;
    // Registra las fuentes aleatorias conocidas con sus formularios de alta y edicion
    procedure registrarFuentes;
    // Registra los combustibles conocidos con sus formularios de alta y edicion
    procedure registrarCombustibles;

    { procedure cargarDatosListadoMantenimiento;
      procedure actualizarAnioTablaMantenimiento(anio: Integer);
      procedure actualizarTablaMantenimiento(primerSemana, ultimaSemana: Integer);

      procedure agregarMantenimiento(actor: TActor ; col: Integer);
      procedure modificarMantenimiento; }

    procedure validarCambioTablaPostes(tabla: TStringGrid);

    procedure intentarCargarDeParametros;
    // procedure eliminarFuncionesPrivadasNoReferenciadas;
    // Crea una sala nueva con valores por defecto
    procedure crearSalaIni;
    // Carga una sala de juego de un archivo de texto (seleccionado en DCargarSala)
    procedure abrir;
    // Guarda la sala de juego en el archivo indicado por DSalvarSala
    procedure guardar;
    procedure abrirMonitores;
    procedure guardarMonitores;

    // Carga en el formulario los valores de la sala
    procedure Init;
    // Carga en el formulario los valores de los monitores
    procedure InitMonitores;
    // Separa los actores en los tabs que les corresponden
    procedure cargarListados;
    // Borra la sala actual, las referencias y las listas de actores asociados a los tabs
    procedure LimpiarSala;
    // Borra el manejador de monitores y lo pone a nil
    procedure LimpiarManejadorMonitores;

    // Carga los valores de los actores como si se estuviera simulando y se
    // hubiera llegado a fecha, retorna el paso de tiempo al que se llego
    // paso contiene el ultimo paso que ha sido preparado, se agrega para
    // poder preparar varios pasos seguidos de forma eficiente
    { function prepararSala(fecha: TFecha ; paso, horasDelPaso: Integer): Integer;
      procedure manejarExcepcionPrepararSala(e: Exception); }

    procedure inicializarNuevoListadoActores;
  protected
    function validarFechasOptSim: boolean;
    function validarFormulario: boolean; override;
  public
    sala: TSalaDeJuego;
    manejadorMonitores: TManejadoresDeMonitores;

    // Manipulacion de actores
    // Retornan NIL si el usuario da cancelar y el actor resultado si dió guardar
    function altaActorClaseBase(claseBase: TClass): TActor;
    function altaActor(const nombreTab: string): TActor;
    function editarActor(actor: TActor): TActor;
    function clonarActor(actorOrig: TActor): TActor;

    // Retornan true si el actor se elimino, false si no
    function eliminarActor(actor: TActor): boolean;
    function eliminarNodo(nodo: TNodo): boolean;

    function altaActorCast(const nombreTab: string): TCosaConNombre;
    function clonarActorCast(actorOrig: TCosaConNombre): TCosaConNombre;
    function eliminarActorCast(actor: TCosaConNombre): boolean;

    // Para dar de alta sin editar, en una importación
    function agregarActor(actor: TActor): boolean;
    procedure importar;

    procedure actualizarTablaActores;
    // Fin de manipulacion de actores

    // Manipulacion de fuentes
    // Retornan NIL si el usuario da cancelar y la fuente resultado si dió guardar
    function altaFuente: TFuenteAleatoria;
    function editarFuente(fuente: TFuenteAleatoria): TFuenteAleatoria;
    function clonarFuente(fuenteOrig: TFuenteAleatoria): TFuenteAleatoria;
    // Retornan true si la fuente se elimino, false si no
    function eliminarFuente(fuente: TFuenteAleatoria): boolean;
    procedure actualizarTablaFuentes;


    // Manipulacion de combustibles
    function altaCombustible: TCombustible;
    function editarCombustible(combustible: TCombustible): TCombustible;
    function clonarCombustible(combustibleOrig: TCombustible): TCombustible;
    // Retornan true si la fuente se elimino, false si no
    function eliminarCombustible(combustible: TCombustible): boolean;
    procedure actualizarTablaCombustibles;

    function editarMantenimiento(fila: integer; clonar: boolean): integer;
    procedure eliminarMantenimiento(fila: integer);
    procedure altaMantenimiento;
    procedure actualizarTablaMantenimientos;
    function validarCeldaMantenimientos(listado: TStringGrid;
      fila, columna: integer): boolean;
    procedure cambioValorMantenimientos(listado: TStringGrid; fila, columna: integer);

    procedure editarMonitor(fila: integer; clonar: boolean);
    procedure eliminarMonitor(fila: integer);
    procedure altaMonitor;
    procedure actualizarTablaMonitores;
    procedure crearMonitorSimResPorDefecto;

    procedure Free;
    procedure ShowHelp(msg: string);

    function fechaIniToString(fecha: TFecha): string;
    function fechaFinToString(fecha: TFecha): string;
    function StringToFecha(const fecha: string): TFecha;

    function darListaParaClase(actor: TCosaConNombre;
      iSala: TSalaDeJuego): TListaDeCosasConNombre;
    function hacerPathRelativoASala(const path: string): string;
  end;

procedure msgAdvertenciaCargandoDeArchivo(msg: string);
procedure msgErrorCargandoDeArchivo(msg: string);

var
  FSimSEEEdit: TFSimSEEEdit;

implementation

{$IFDEF FPC-LCL}
{$R *.lfm}
{$ELSE}
{$R *.dfm}
{$ENDIF}

function TFSimSEEEdit.altaActorClaseBase(claseBase: TClass): TActor;
var
  nombreTipo: string;
  infoClase: TInfoCosaConNombre;
  formularioEdicion: TBaseEditoresCosasConNombre;
  nuevoActor: TActor;
begin
  nuevoActor := nil;
  nombreTipo := selectTipo(self, infoTabs.nombresSubClases(claseBase));
  if nombreTipo <> '' then
  begin
    infoClase := infoTabs.getInfoActor(nombreTipo);
    if infoClase <> nil then
    begin
      formularioEdicion := infoClase.ClaseEditor.Create(self, sala, infoClase.clase,
        NIL);
      if formularioEdicion.ShowModal = mrOk then
      begin
        nuevoActor := TActor(formularioEdicion.darResultado);
        self.agregarActor(nuevoActor);
        actualizarTablaActores;
        utilidades.sgBuscarYSeleccionarFila(sgActores, 0, nuevoActor.nombre);
      end;
      formularioEdicion.Free;
    end
    else
      raise Exception.Create(exFormularioEdicionParaClase + nombreTipo);
  end;
  Result := nuevoActor;
end;

function TFSimSEEEdit.altaActor(const nombreTab: string): TActor;
var
  nombreTipo: string;
  infoClase: TInfoCosaConNombre;
  formularioEdicion: TBaseEditoresCosasConNombre;
  nuevoActor: TActor;
begin
  nuevoActor := nil;
  nombreTipo := selectTipo(self, infoTabs.nombresTiposTab(nombreTab));
  if nombreTipo <> '' then
  begin
    infoClase := infoTabs.getInfoActor(nombreTab, nombreTipo);
    if infoClase <> nil then
    begin
      formularioEdicion := infoClase.ClaseEditor.Create(self, sala, infoClase.clase,
        NIL);
      if formularioEdicion.ShowModal = mrOk then
      begin
        nuevoActor := TActor(formularioEdicion.darResultado);
        self.agregarActor(nuevoActor);
        actualizarTablaActores;
        utilidades.sgBuscarYSeleccionarFila(sgActores, 0, nuevoActor.nombre);
      end;
      formularioEdicion.Free;
    end
    else
      raise Exception.Create(exFormularioEdicionParaClase + nombreTipo);
  end;
  Result := nuevoActor;
end;

function TFSimSEEEdit.editarActor(actor: TActor): TActor;
var
  infoClase: TInfoCosaConNombre;
  formularioEdicion: TBaseEditoresCosasConNombre;
  res: TActor;
begin
  infoClase := infoTabs.getInfoActor(actor.ClassType);
  if infoClase <> nil then
  begin
    formularioEdicion := infoClase.ClaseEditor.Create(self, sala, actor.ClassType, actor);
    if formularioEdicion.ShowModal = mrOk then
    begin
      res := actor;
      guardado := False;
      actualizarTablaActores;
      utilidades.sgBuscarYSeleccionarFila(sgActores, 0, actor.nombre);
    end
    else
      res := nil;
    formularioEdicion.Free;
    Result := res;
  end
  else
    raise Exception.Create(exFormularioEdicionParaClase + actor.ClaseNombre);
end;

function TFSimSEEEdit.clonarActor(actorOrig: TActor): TActor;
var
  infoClase: TInfoCosaConNombre;
  formularioEdicion: TBaseEditoresCosasConNombre;
  nuevoActor: TActor;
begin
  infoClase := infoTabs.getInfoActor(actorOrig.ClassType);
  if infoClase <> nil then
  begin
    nuevoActor := usalasdejuegoparaeditor.Clonar_Y_ResolverReferencias(sala, actorOrig)
      as TActor;

    formularioEdicion := infoClase.ClaseEditor.Create(self, sala, nuevoActor.ClassType,
      nuevoActor);
    if formularioEdicion.ShowModal = mrOk then
    begin
      agregarActor(nuevoActor);
      actualizarTablaActores;
      utilidades.sgBuscarYSeleccionarFila(sgActores, 0, nuevoActor.nombre);
    end
    else
    begin
      nuevoActor.Free;
      nuevoActor := nil;
    end;
    formularioEdicion.Free;
    Result := nuevoActor;
  end
  else
    raise Exception.Create(exFormularioEdicionParaClase + actorOrig.ClaseNombre);
end;

function TFSimSEEEdit.eliminarActor(actor: TActor): boolean;
var
  texto: string;
  res: Boolean;
begin
  if not(actor is TNodo) then
  begin
    // Chequeo que nadie lo referencie
    if usalasdejuegoparaeditor.existeReferenciaALaCosaConNombre(actor, sala) then
    begin
      ShowMessage(mesNoSePuedeEliminarActor + actor.DescClase + ' ' +
        actor.nombre +
          mesExisteReferenciaAEl +
          mesElimineLasReferenciasVuelvaIntentarlo);
      res := False;
    end
    else
    begin
      texto := mesConfirmaEliminarActor + actor.DescClase + ' "'
              + actor.nombre + '"?';
      if (Application.MessageBox(PChar(texto), pchar(mesConfirmarEliminacion),
          MB_OKCANCEL + MB_ICONEXCLAMATION) = IDOK) then
      begin
        darListaParaClase(actor, Sala).Remove(actor);
        usalasDeJuegoParaEditor.eliminarActor(Sala, actor);
        guardado := False;
        actualizarTablaActores;
        res := True;
      end
      else
        res := False;
    end;
  end
  else
    res := eliminarNodo(TNodo(actor));
  Result := res;
end;

function TFSimSEEEdit.eliminarNodo(nodo: TNodo): boolean;
var
  texto: string;
  lista: TList;
  i: Integer;
  res: Boolean;
begin
  Lista := TList.Create();

  // Agrego generadores
  for i := 0 to Sala.Gens.Count - 1 do
  begin
    if (TActor(Sala.Gens[i]) is TActorNodal) and
      (TActorNodal(Sala.Gens[i]).referenciaAlNodo(nodo)) then
      lista.Add(Sala.Gens[i]);
  end;

  // Agrego demandas
  for i := 0 to Sala.Dems.Count - 1 do
  begin
    if (TActor(Sala.Dems[i]) is TActorNodal) and
      (TActorNodal(Sala.Dems[i]).referenciaAlNodo(nodo)) then
      lista.Add(Sala.Dems[i]);
  end;

  // Agrego arcos
  for i := 0 to Sala.Arcs.Count - 1 do
  begin
    if (TActor(Sala.Arcs[i]) is TActorNodal) and
      (TActorNodal(Sala.Arcs[i]).referenciaAlNodo(nodo)) then
      lista.Add(Sala.Arcs[i]);
  end;

  // Agrego comercio internacional
  for i := 0 to sala.ComercioInternacional.Count - 1 do
  begin
    if (TActor(Sala.ComercioInternacional[i]) is TActorNodal) and
      (TActorNodal(Sala.ComercioInternacional[i]).referenciaAlNodo(nodo)) then
      lista.Add(Sala.ComercioInternacional[i]);
  end;

  if lista.Count > 0 then
  begin
    texto :=
      mesEliminaNodoActoresReferenciasVacias
      + #13#10;
    for i := 0 to lista.Count - 1 do
      texto := texto + TActor(lista[i]).nombre + #13#10;
    texto := texto + mesElimineLasReferenciasVuelvaIntentarlo;
    ShowMessage(texto);
    res := False;
  end
  else
  begin
    texto := texto + mesConfirmaEliminarNodo + nodo.nombre + '"?';
    if (Application.MessageBox(PChar(texto), pchar(mesConfirmarEliminacion),
        MB_OKCANCEL + MB_ICONEXCLAMATION) = IDOK) then
    begin
      darListaParaClase(nodo, Sala).Remove(nodo);
      usalasDeJuegoParaEditor.eliminarActor(Sala, TActor(nodo));
      guardado := False;
      actualizarTablaActores;
      res := True;
    end
    else
      res := False;
  end;
  lista.Free;
  Result := res;
end;

function TFSimSEEEdit.altaActorCast(const nombreTab: string): TCosaConNombre;
begin
  result := altaActor(nombreTab);
end;

function TFSimSEEEdit.clonarActorCast(actorOrig: TCosaConNombre): TCosaConNombre;
begin
  result := clonarActor(TActor(actorOrig));
end;

function TFSimSEEEdit.eliminarActorCast(actor: TCosaConNombre): boolean;
begin
  result := eliminarActor(TActor(actor));
end;

procedure TFSimSEEEdit.eMaxNItersOptExit(Sender: TObject);
begin
  if validarEditInt(eMaxNItersOpt, 0, MaxInt) then
    sala.globs.NMAX_ITERACIONESDELPASO_OPT := StrToInt(eMaxNItersOpt.Text);
end;

procedure TFSimSEEEdit.eMaxNItersSimExit(Sender: TObject);
begin
  if validarEditInt(eMaxNItersSim, 0, MaxInt) then
    sala.globs.NMAX_ITERACIONESDELPASO_SIM := StrToInt(eMaxNItersSim.Text);
end;

function TFSimSEEEdit.agregarActor(actor: TActor): boolean;
var
  actoresTab: TListaDeCosasConNombre;
  resultado: Boolean;
begin
  if self.Sala = nil then
    raise Exception.Create('TFSimSEEEdit.agregarActor. Aun no se ha creado una sala!')
  else
  begin
    resultado := addCosaConNombre(Sala, actor);
    if resultado then
    begin
      actoresTab := darListaParaClase(actor, self.Sala);
      if actoresTab <> nil then
        actoresTab.Add(actor);
      uSalasDeJuegoParaEditor.resolverReferenciasContraSala(sala, False);
      Sala.PrepararseYPubliVars;
      guardado := False;
    end;
    Result := resultado;
  end;
end;

procedure TFSimSEEEdit.importar;
var
  cosaParticipeDeMercado: TCosaParticipeDeMercado;
  arch: TArchiTexto;
  k: Integer;
  nomOrig: string;
  iBusquedaNombre: integer;
begin
  arch := nil;
  try
    k := uCosaConNombre.referenciasSinResolver;
    assert(k = 0, 'TFSimSEEEdit.importar: cantReferenciasSinResolver <> 0');

    arch := TArchiTexto.CreateForRead(DImportarActor.FileName, True);
    arch.rd(':', TCosa(cosaParticipeDeMercado));
    if usalasdejuegoparaeditor.buscarCosaConNombre(sala, cosaParticipeDeMercado.nombre) <> NIL then
    begin
      nomOrig := cosaParticipeDeMercado.nombre;
      iBusquedaNombre := 2;
      cosaParticipeDeMercado.nombre := nomOrig + '(' + IntToStr(iBusquedaNombre) + ')';
      while usalasdejuegoparaeditor.buscarCosaConNombre(sala, cosaParticipeDeMercado.nombre)
        <> NIL do
      begin
        iBusquedaNombre := iBusquedaNombre + 1;
        cosaParticipeDeMercado.nombre := nomOrig + '(' + IntToStr(iBusquedaNombre) + ')';
      end;
      uCosaConNombre.cambiar_NombreDelReferidoEnReferenciasPosterioresAK(k, nomOrig,
        cosaParticipeDeMercado.nombre, cosaParticipeDeMercado.ClassName);
    end;

    if cosaParticipeDeMercado is TActor then
    begin
      if usalasdejuegoParaEditor.resolverReferenciasContraSala(sala, True) > 0 then
      begin
        ShowMessage(mesElActor + cosaParticipeDeMercado.ClaseNombre + mesReferenciasSinResolverResuelvalas);
        cosaParticipeDeMercado := editarActor(TActor(cosaParticipeDeMercado));
        uCosaConNombre.LimpiarReferencias;
        // uCosaConNombre.eliminar_referencias_del(actor);
      end;
      if cosaParticipeDeMercado <> NIL then
      begin
        agregarActor(TActor(cosaParticipeDeMercado));
        actualizarTablaActores;
        manejadorListadoEditores.notificarGuardarDatos;
      end;
    end
    else if cosaParticipeDeMercado is TFuenteAleatoria then
    begin
      if usalasdejuegoParaEditor.resolverReferenciasContraSala(sala, True) > 0 then
      begin
        ShowMessage(mesLaFuenteAleatoria + cosaParticipeDeMercado.ClaseNombre +
            mesReferenciasSinResolverResuelvalas);
        cosaParticipeDeMercado := editarFuente(TFuenteAleatoria(cosaParticipeDeMercado));
        uCosaConNombre.LimpiarReferencias;
        // uCosaConNombre.eliminar_referencias_del(actor);
      end;
      if cosaParticipeDeMercado <> NIL then
      begin
        sala.listaFuentes.Add(cosaParticipeDeMercado);
        actualizarTablaFuentes;
      end;
    end
    else
      raise Exception.Create('TFSimSEEEdit.importar: importar cosas de clase ' + cosaParticipeDeMercado.ClassName + ' no implementado');
  except
    on E: EInOutError do
    begin
      ShowMessage(mesErrorImportandoActor + #13 + E.Message +
          '.' + #13 + mesArchivoAbiertoONoExiste);
      uCosaConNombre.LimpiarReferencias;
    end;
    on E: Exception do
    begin
      ShowMessage(mesErrorImportandoActor + #13 + E.Message + '.');
      uCosaConNombre.LimpiarReferencias;
    end;
  end;
  if arch <> nil then
    arch.Free;
end;



procedure TFSimSEEEdit.inicializarNuevoListadoActores;
begin
  if manejadorListadoEditores <> NIL then
    manejadorListadoEditores.Free;
  manejadorListadoEditores := TManejadorListadoEditores.Create(lbActores,
                                gbEditorActores, sbEditorActores, TCActoresV2, bAgregarActorV2,
                                bEliminarActorV2, bClonarActorV2, sala.listaActores,
                                sala, altaActorCast, clonarActorCast, eliminarActorCast,
                                PCEditMain, TSActoresV2);
  manejadorListadoEditores.listaObservadoresCambioDatos.Add(observadorCambiosEditoresActores);
end;

procedure TFSimSEEEdit.actualizarTablaActores;
var
  i: Integer;
  actor: TActor;
  ListaDeActores: TListaDeCosasConNombre;
  TipoActor: string;
begin
  BGenerarResumenTermico.Visible := False;
  TipoActor := TCActores.Tabs[TCActores.tabindex];

  if TipoActor = '?' then
  begin
    PActores.Visible := False;
    verdoc(self, 'editor-actores', 'Actores');
    TCActores.TabIndex := 0;
    actualizarTablaActores();
    exit;
  end;

  PActores.Visible := True;
  if TipoActor = strTabGeneradoresTermicos then
  begin
    BGenerarResumenTermico.Visible := True;
    ListadeActores := Sala.Gens;
    hid_ActoresListaEspecifica := '(Actores) Térmicas';
    BGenerarResumenTermico.Visible := sala.Gens.Count > 0;
  end
  else if TipoActor = strTabDemandas then
  begin
    ListadeActores := Sala.Dems;
    hid_ActoresListaEspecifica := '(Actores) Demandas';
  end
  else if TipoActor = strTabRed then
  begin
    ListadeActores := Sala.Nods;
    hid_ActoresListaEspecifica := '(Actores) Red';
  end
  else if TipoActor = strTabGeneradoresHidraulicos then
  begin
    ListadeActores := Sala.Gens;
    hid_ActoresListaEspecifica := '(Actores) Hidráulicas';
  end
  else if TipoActor = strTabEolica then
  begin
    ListadeActores := Sala.Gens;
    hid_ActoresListaEspecifica := '(Actores) Eólica';
  end
  else if TipoActor = strTabComercioInternacional then
  begin
    ListadeActores := sala.ComercioInternacional;
    hid_ActoresListaEspecifica := '(Actores) Internacional';
  end
  else
    raise Exception.Create('TFSimSEEEdit.actualizarTablaActores: Tipo no registrado' +
        TipoActor + '.');

  ListadeActores.Sort(uCosaConNombre.ordenString);


  ListasDeActoresTabs[TCActores.TabIndex].Sort(uCosaConNombre.ordenString);

  sgActores.RowCount := ListasDeActoresTabs[TCActores.TabIndex].Count + 1;
  if sgActores.RowCount > 1 then
    sgActores.FixedRows := 1
  else
    sgLimpiarSeleccion(sgActores);

  for i := 0 to ListasDeActoresTabs[TCActores.TabIndex].Count - 1 do
  begin
    actor := TActor(ListasDeActoresTabs[TCActores.TabIndex][i]);
    sgActores.Cells[0, i + 1] := actor.nombre;
    sgActores.Cells[1, i + 1] := actor.DescClase;
    sgActores.Cells[2, i + 1] := fechaIniToString(actor.nacimiento);
    sgActores.Cells[3, i + 1] := fechaFinToString(actor.muerte);
    sgActores.Cells[4, i + 1]:= actor.infoAd__;
  end;

  utilidades.AutoSizeTypedColsAndTable(sgActores, TiposColActores, iconos, TSActores,
    maxAnchoTablaEnorme, maxAlturaTablaGrande,
    TSimSEEEditOptions.getInstance.deshabilitarScrollHorizontalEnListados);

  BAgregarActor.Left := (sgActores.Left + sgActores.Width) - BAgregarActor.Width;
  BExportar.Left := BAgregarActor.Left - BExportar.Width - 10;
  BImportar.Left := BExportar.Left - BImportar.Width - 10;
  BGenerarResumenTermico.Left := BImportar.Left - BGenerarResumenTermico.Width - 10;
end;

function TFSimSEEEdit.altaFuente: TFuenteAleatoria;
var
  form: TBaseEditoresCosasConNombre;
  tipoStr: string;
  TipoFuente: TClaseDeFuenteAleatoria;
  tipoEditorFuente: TClaseEditoresCosasConNombre;
  res: TFuenteAleatoria;
begin
  tipoStr := selectTipo(self, uInfoCosa.InfoFuentes.descsClase);
  if tipoStr <> '' then
  begin
    TipoFuente := TClaseDeFuenteAleatoria(uInfoCosa.InfoFuentes.tipoDeCosa(tipoStr));
    tipoEditorFuente := TClaseEditoresCosasConNombre
      (uInfoCosa.InfoFuentes.getTipoEditor(TipoFuente));

    // Muestro el editor de la fuente seleccionada
    form := tipoEditorFuente.Create(self, sala, TipoFuente, nil);
    if form.ShowModal = mrOk then
    begin
      res := form.darResultado as TFuenteAleatoria;
      Sala.listaFuentes.Add(res);
      actualizarTablaFuentes;
      guardado := False;
      sgBuscarYSeleccionarFila(sgFuentes, 0, res.nombre);
      sala.PrepararseYPubliVars;
    end
    else
      res := nil;
    form.Free;
  end
  else
    res := NIL;
  Result := res;
end;


function TFSimSEEEdit.editarFuente(fuente: TFuenteAleatoria): TFuenteAleatoria;
var
  form: TBaseEditoresCosasConNombre;
  TipoEditor: TClaseEditoresCosasConNombre;
  res: TFuenteAleatoria;
begin
  TipoEditor := TClaseEditoresCosasConNombre(uInfoCosa.InfoFuentes.getTipoEditor
      (fuente.ClassType));
  if TipoEditor <> nil then
  begin
    form := TipoEditor.Create(self, Sala, fuente.ClassType, fuente);
    if form.ShowModal = mrOk then
    begin
      res := form.darResultado as TFuenteAleatoria;
      guardado := False;
      actualizarTablaFuentes;
      utilidades.sgBuscarYSeleccionarFila(sgFuentes, 0, res.nombre);
    end
    else
      res := nil;
    form.Free;
  end
  else
  begin
    raise Exception.Create(exEditorNoRegistradoClase + fuente.ClassName);
  end;
  Result := res;
end;

function TFSimSEEEdit.clonarFuente(fuenteOrig: TFuenteAleatoria): TFuenteAleatoria;
var
  TipoEditor: TClaseEditoresCosasConNombre;
  formularioEdicion: TBaseEditoresCosasConNombre;
  nuevaFuente: TFuenteAleatoria;
begin
  TipoEditor := TClaseEditoresCosasConNombre(uInfoCosa.InfoFuentes.getTipoEditor
      (fuenteOrig.ClassType));
  if TipoEditor <> nil then
  begin
    nuevaFuente := usalasdejuegoparaeditor.Clonar_Y_ResolverReferencias(sala, fuenteOrig)
      as TFuenteAleatoria;

    formularioEdicion := TipoEditor.Create(self, Sala, nuevaFuente.ClassType, nuevaFuente);
    if formularioEdicion.ShowModal = mrOk then
    begin
      sala.listaFuentes.Add(nuevaFuente);
      actualizarTablaFuentes;
      utilidades.sgBuscarYSeleccionarFila(sgFuentes, 0, nuevaFuente.nombre);
    end
    else
    begin
      nuevaFuente.Free;
      nuevaFuente := nil;
    end;
    formularioEdicion.Free;
    Result := nuevaFuente;
  end
  else
  begin
    raise Exception.Create(exEditorNoRegistradoClase + fuenteOrig.ClassName);
  end;
end;

function TFSimSEEEdit.eliminarFuente(fuente: TFuenteAleatoria): boolean;
var
  res: Boolean;
  texto: string;
begin
  if usalasdejuegoparaeditor.existeReferenciaALaCosaConNombre(fuente, sala) then
  begin
    ShowMessage(mesNoSePuedeEliminarFuenteReferencia +
        mesElimineLasReferenciasVuelvaIntentarlo);
    res := False;
  end
  else
  begin
    texto := mesConfirmaDeseaEliminarFuentes + fuente.nombre + '"?';
    if (Application.MessageBox(PChar(texto), pchar(mesConfirmarEliminacion),
        MB_OKCANCEL + MB_ICONEXCLAMATION) = IDOK) then
    begin
      Sala.listaFuentes.remove(fuente);
      fuente.Free;
      actualizarTablaFuentes;
      guardado := False;
      res := true;
    end
    else
      res := False;
  end;
  Result := res;
end;

procedure TFSimSEEEdit.actualizarTablaFuentes;
var
  i: Integer;
  aux: TFuenteAleatoria;

begin
  sgFuentes.RowCount := Sala.listaFuentes.Count + 1;
  if sgFuentes.RowCount > 1 then
    sgFuentes.FixedRows := 1
  else
    sgLimpiarSeleccion(sgFuentes);

  for i := 0 to Sala.listaFuentes.Count - 1 do
  begin
    aux := TFuenteAleatoria(Sala.listaFuentes[i]);
    sgFuentes.Cells[0, i + 1] := aux.nombre;
    sgFuentes.Cells[1, i + 1] := aux.DescClase;
    sgFuentes.Cells[2, i + 1] := aux.InfoAd__;
  end;

  for i := 0 to sgFuentes.ColCount - 1 do
    utilidades.AutoSizeTypedCol(sgFuentes, i, TiposColFuentes[i], iconos);
  utilidades.AutosizeTable(TSFuentes, sgFuentes, maxAnchoTablaEnorme,
    maxAlturaTablaGrande, TSimSEEEditOptions.getInstance.
      deshabilitarScrollHorizontalEnListados);
  BAgregarFuente.Left := (sgFuentes.Left + sgFuentes.Width) - BAgregarFuente.Width;
end;



function TFSimSEEEdit.altaCombustible: TCombustible;
var
  form: TBaseEditoresCosasConNombre;
  tipoStr: string;
  TipoCombustible: TClaseDeCombustible;
  tipoEditorCombustible: TClaseEditoresCosasConNombre;
  res: TCombustible;
begin
  tipoStr := selectTipo(self, uInfoCosa.InfoCombustibles.descsClase);

  if tipoStr <> '' then
  begin
    TipoCombustible := TClaseDeCombustible(uInfoCosa.InfoCombustibles.tipoDeCosa(tipoStr));
    tipoEditorCombustible := TClaseEditoresCosasConNombre
      (uInfoCosa.InfoCombustibles.getTipoEditor(TipoCombustible));

    // Muestro el editor del combustible seleccionado
    form := tipoEditorCombustible.Create(self, sala, TipoCombustible, nil);
    if form.ShowModal = mrOk then
    begin
      res := form.darResultado as TCombustible;
      Sala.listaCombustibles.Add(res);
      actualizarTablaCombustibles;
      guardado := False;
      sgBuscarYSeleccionarFila(sgCombustible, 0, res.nombre);
      sala.PrepararseYPubliVars;
    end
    else
      res := nil;
    form.Free;
  end
  else
    res := NIL;
  Result := res;
end;

function TFSimSEEEdit.editarCombustible(combustible: TCombustible): TCombustible;
var
  form: TBaseEditoresCosasConNombre;
  TipoEditor: TClaseEditoresCosasConNombre;
  res: TCombustible;
begin
  TipoEditor := TClaseEditoresCosasConNombre(uInfoCosa.InfoCombustibles.getTipoEditor
      (combustible.ClassType));
  if TipoEditor <> nil then
  begin
    form := TipoEditor.Create(self, Sala, combustible.ClassType, combustible);
    if form.ShowModal = mrOk then
    begin
      res := form.darResultado as TCombustible;
      guardado := False;
      actualizarTablaCombustibles;
      utilidades.sgBuscarYSeleccionarFila(sgCombustible, 0, res.nombre);
    end
    else
      res := nil;
    form.Free;
  end
  else
  begin
    raise Exception.Create(exEditorNoRegistradoClase + combustible.ClassName);
  end;
  Result := res;
end;

function TFSimSEEEdit.clonarCombustible(combustibleOrig: TCombustible): TCombustible;
var
  TipoEditor: TClaseEditoresCosasConNombre;
  formularioEdicion: TBaseEditoresCosasConNombre;
  nuevoCombustible: TCombustible;
begin
  TipoEditor := TClaseEditoresCosasConNombre(uInfoCosa.InfoCombustibles.getTipoEditor
      (combustibleOrig.ClassType));
  if TipoEditor <> nil then
  begin
    nuevoCombustible := usalasdejuegoparaeditor.Clonar_Y_ResolverReferencias(sala, combustibleOrig)
      as TCombustible;

    formularioEdicion := TipoEditor.Create(self, Sala, nuevoCombustible.ClassType, nuevoCombustible);
    if formularioEdicion.ShowModal = mrOk then
    begin
      sala.listaCombustibles.Add(nuevoCombustible);
      actualizarTablaCombustibles;
      sgBuscarYSeleccionarFila(sgCombustible, 0, nuevoCombustible.nombre);
    end
    else
    begin
      nuevoCombustible.Free;
      nuevoCombustible := nil;
    end;
    formularioEdicion.Free;
    Result := nuevoCombustible;
  end
  else
  begin
    raise Exception.Create(exEditorNoRegistradoClase + combustibleOrig.ClassName);
  end;
end;

function TFSimSEEEdit.eliminarCombustible(combustible: TCombustible): boolean;
var
  res: Boolean;
  texto: string;
begin
  if usalasdejuegoparaeditor.existeReferenciaALaCosaConNombre(combustible, sala) then
  begin
    ShowMessage(mesNoSePuedeEliminarCombustibleReferencia +
        mesElimineLasReferenciasVuelvaIntentarlo);
    res := False;
  end
  else
  begin
    texto := mesConfirmaDeseaEliminarCombustible + combustible.nombre + '"?';
    if (Application.MessageBox(PChar(texto), pchar(mesConfirmarEliminacion),
        MB_OKCANCEL + MB_ICONEXCLAMATION) = IDOK) then
    begin
      Sala.listaCombustibles.remove(combustible);
      combustible.Free;
      actualizarTablaCombustibles;
      guardado := False;
      res := true;
    end
    else
      res := False;
  end;
  Result := res;
end;

procedure TFSimSEEEdit.actualizarTablaCombustibles;
var
  i: Integer;
  aux: TCombustible;
begin
  sgCombustible.RowCount := Sala.listaCombustibles.Count + 1;
  if sgCombustible.RowCount > 1 then
    sgCombustible.FixedRows := 1
  else
    sgLimpiarSeleccion(sgCombustible);

  for i := 0 to Sala.listaCombustibles.Count - 1 do
  begin
    aux := TCombustible(Sala.listaCombustibles[i]);
    sgCombustible.Cells[0, i + 1] := aux.nombre;
    sgCombustible.Cells[1, i + 1] := aux.DescClase;
    sgCombustible.Cells[2, i + 1] := aux.InfoAd__;
  end;

  for i := 0 to sgCombustible.ColCount - 1 do
    utilidades.AutoSizeTypedCol(sgCombustible, i, TiposColCombustibles[i], iconos);
  utilidades.AutosizeTable(TSCombustible, sgCombustible, maxAnchoTablaEnorme,
    maxAlturaTablaGrande, TSimSEEEditOptions.getInstance.
      deshabilitarScrollHorizontalEnListados);
  BAgregarCombustible.Left := (sgCombustible.Left + sgCombustible.Width) - BAgregarCombustible.Width;
end;

procedure TFSimSEEEdit.Free;
var
  i: integer;
begin
  Sala.Free;
  SetLength(TiposColActores, 0);
  SetLength(TiposColMonitores, 0);
  for i := 0 to high(ListasDeActoresTabs) do
    ListasDeActoresTabs[i].Free;
  SetLength(ListasDeActoresTabs, 0);

  listaMantenimientos.Free;
  inherited Free;
end;

procedure TFSimSEEEdit.ShowHelp(msg: string);
begin
  ShowMessage(msg);
end;

function TFSimSEEEdit.fechaIniToString(fecha: TFecha): string;
begin
  if TSimSEEEditOptions.getInstance.fechasAutomaticas then
  begin
    if fecha.dt = 0 then
      Result := 'Auto'
    else
      result := fecha.AsStr
  end
  else if fecha.dt = 0 then
  begin
    Result := '1/1/1900';
    { if sala.globs.fechaIniSim.EsMayorQue(sala.globs.fechaIniOpt) <= 0 then
      result:= sala.globs.fechaIniSim.AsStr
      else
      result:= sala.globs.fechaIniOpt.AsStr; }
  end
  else
    Result := fecha.AsStr;
end;

function TFSimSEEEdit.fechaFinToString(fecha: TFecha): string;
begin
  if TSimSEEEditOptions.getInstance.fechasAutomaticas then
  begin
    if fecha.dt = 0 then
      Result := 'Auto'
    else
      result := fecha.AsStr
  end
  else if fecha.dt = 0 then
    Result := '9/9/9999'
    { if sala.globs.fechaFinSim.EsMayorQue(sala.globs.fechaFinOpt) >= 0 then
      result:= sala.globs.fechaFinSim.AsStr
      else
      result:= sala.globs.fechaFinOpt.AsStr }
  else
    Result := fecha.AsStr;
end;

function TFSimSEEEdit.StringToFecha(const fecha: string): TFecha;
var
  res: TFecha;
begin
  if (fecha = 'Auto') or (fecha = '0') then
    res := TFecha.Create_Dt(0)
  else
    res := TFecha.Create_Str(fecha);
  Result := res;
end;

function TFSimSEEEdit.darListaParaClase(actor: TCosaConNombre;
  iSala: TSalaDeJuego): TListaDeCosasConNombre;
var
  i: integer;
  resultado: TListaDeCosasConNombre;
begin
  resultado := nil;
  if Sala = nil then
    raise Exception.Create('TFSimSEEEdit.darListaParaClase: sala = NIL');
  if (actor is TGeneradorHidraulico) then
  begin
    for i := 0 to TCActores.Tabs.Count - 1 do
      if TCActores.Tabs[i] = strTabGeneradoresHidraulicos then
      begin
        resultado := ListasDeActoresTabs[i];
        break;
      end;
  end
  else if (actor is TGter) then
  begin
    for i := 0 to TCActores.Tabs.Count - 1 do
      if TCActores.Tabs[i] = strTabGeneradoresTermicos then
      begin
        resultado := ListasDeActoresTabs[i];
        break;
      end
  end
  else if (actor is TGenerador) then // No es ni térmico ni hidráulico
  begin
    for i := 0 to TCActores.Tabs.Count - 1 do
      if TCActores.Tabs[i] = strTabEolica then
      begin
        resultado := ListasDeActoresTabs[i];
        break;
      end
  end
  else if (actor is TDemanda) then
  begin
    for i := 0 to TCActores.Tabs.Count - 1 do
      if TCActores.Tabs[i] = strTabDemandas then
      begin
        resultado := ListasDeActoresTabs[i];
        break;
      end;
  end
  else if ( actor is TNodo ) or ( actor is TArco ) then
  begin
    for i := 0 to TCActores.Tabs.Count - 1 do
      if TCActores.Tabs[i] = strTabRed then
      begin
        resultado := ListasDeActoresTabs[i];
        break;
      end;
  end
  else if actor is TComercioInternacional then
  begin
    for i := 0 to TCActores.Tabs.Count - 1 do
      if TCActores.Tabs[i] = strTabComercioInternacional then
      begin
        resultado := ListasDeActoresTabs[i];
        break;
      end;
  end
  else if actor is TCombustible then
  begin
    for i := 0 to TCActores.Tabs.Count - 1 do
      if TCActores.Tabs[i] = strTabCombustibles then
      begin
        resultado := ListasDeActoresTabs[i];
        break;
      end;
  end
  else if actor is TFuenteAleatoria then
    resultado := nil
  else
    raise Exception.Create(exTipoActorDesconocido + actor.DescClase);
  Result := resultado;
end;

procedure TFSimSEEEdit.ddd1Click(Sender: TObject);
begin
  verdoc(self, 'versiones', 'versiones');
end;


function TFSimSEEEdit.hacerPathRelativoASala(const path: string): string;
var
  res, pathSala: string;
  cntDirectoriosArriba, i: integer;
begin
  if DCargarSala.FileName <> '' then
    pathSala := ExtractFilePath(DCargarSala.FileName)
  else
    pathSala := getDir_Corridas;
  res := path;
  cntDirectoriosArriba := 0;
  while pos(res, pathSala) = 0 do
  begin
    subirDirectorio(res);
    inc(cntDirectoriosArriba)
  end;
  res := copy(pathSala, Length(res), MAXINT);
  for i := 1 to cntDirectoriosArriba do
    res := '\..' + res;
  Result := res;
end;

procedure TFSimSEEEdit.FormCreate(Sender: TObject);
var
  i: Integer;
  tabs: TStringList;
begin
  WindowState := wsMaximized;
  manejadorListadoEditores := NIL;
  observadorCambiosEditoresActores := TObserverCambioDatosEnHijoDeBaseFormularios.Create(self);
  ChDir(ExtractFilePath(ParamStr(0)));
  crearDirectorios;
  registrarClaseDeCosa(TSimSEEEditOptions.ClassName, TSimSEEEditOptions);

  self.Caption := 'Editor - SimSEE - v' + uversiones.vSimSEEEdit + ' (c) IIE - FING';
  DCargarSala.InitialDir := getDir_Corridas;
  DCargarSala.Filter := 'Archivos SimSEEEdit (*.ese)|*.ese|Todos los Archivos (*.*)|*.*';
  DSalvarSala.InitialDir := getDir_Corridas;
  DSalvarSala.DefaultExt := 'ese';
  DImportarActor.InitialDir := TSimSEEEditOptions.getInstance.libPath;
  DImportarActor.Filter :=
    'Archivos de Actor SimSEE (*.act)|*.act|Todos los Archivos (*.*)|*.*';
  ODCF.InitialDir := getDir_Run;
  ODCF.Filter :=
    'Archivos Binarios de Costos Futuros (*.bin)|*.bin|Todos los Archivos (*.*)|*.*';
  DCargarManejadorMonitores.InitialDir := getDir_Corridas;
  DCargarManejadorMonitores.Filter := 'Archivos de Monitores SimSEE (*.mon)|*.mon';
  DSalvarManejadorMonitores.InitialDir := getDir_Corridas;
  DSalvarManejadorMonitores.Filter := 'Archivos de Monitores SimSEE (*.mon)|*.mon';
  DSalvarManejadorMonitores.DefaultExt := 'mon';

  registrarActores;
  registrarMonitores;
  registrarFuentes;
  registrarCombustibles;

  PCEditMain.ActivePage := PCEditMain.Pages[0];

  // sysutils.DecimalSeparator:= '.';

  ucosa.procMsgValorPorDefecto := SimSEEEditMain.msgAdvertenciaCargandoDeArchivo;
  ucosa.procMsgErrorLectura := SimSEEEditMain.msgErrorCargandoDeArchivo;
  ucosa.procMsgAdvertenciaLectura := SimSEEEditMain.msgAdvertenciaCargandoDeArchivo;
  self.Top := topDef;
  self.Left := leftDef;

  MemoDesc.Lines.Delimiter := separadorDeLineas;
  sala := NIL;
  loQueHabia := '';
  guardado := True;
  guardadoMonitores := True;
  utilidades.AgregarFormatoFecha(LFechaIni);
  utilidades.AgregarFormatoFecha(LFechaFin);
  utilidades.AgregarFormatoFecha(LFIniOpt);
  utilidades.AgregarFormatoFecha(LFFinOpt);

  sgPostes.Cells[0, 0] := rsPosteN;
  for i := 1 to StrToInt(IntNPostes.Text) do
    sgPostes.Cells[i, 0] := IntToStr(i);

  sgPostes.Cells[0, 1] := rsDuracioN;
  utilidades.AutoSizeTable(TSGlobales, sgPostes, maxAnchoTablaEnorme,
    maxAlturaTablaChica, TSimSEEEditOptions.getInstance.
      deshabilitarScrollHorizontalEnListados);

  // Listado de Fuentes Aleatorias
  utilidades.initListado(sgFuentes, [rsFuente, rsTipoDeFuente, rsInformacioNAdicional, encabezadoBTEditar,
    encabezadoBTEliminar, encabezadoBTClonar], TiposColFuentes, true);

  // Listado de Combustibles
  utilidades.initListado(sgCombustible, [rsCombusitbles, rsTipoDeCombustible, rsInformacioNAdicional, encabezadoBTEditar,
    encabezadoBTEliminar, encabezadoBTClonar], TiposColCombustibles, true);

  // Listado de Actores
  utilidades.initListado(sgActores, [rsActor, rsTipoDeActor, rsFechaDeNacimiento,
    rsFechaDeMuerte, rsInformacioNAdicional, encabezadoBTEditar, encabezadoBTEliminar,
    encabezadoBTClonar], TiposColActores, true);

  // Listado de Mantenimientos
  utilidades.initListado(sgMantenimientos, [rsActor, rsTipoDeActor,
    encabezadoTextoEditable + rsFecha,
    encabezadoTextoEditable + rsUnidades, rsPeriodicaQ, encabezadoBTEditar,
    encabezadoBTEliminar, encabezadoBTClonar], TiposColMantenimientos, false);

  // Listado de Monitores
  monitoresEnabled := nil;

  utilidades.initListado(sgMonitores, [rsMonitor, rsTipo, encabezadoCheckBox,
    encabezadoBTEditar, encabezadoBTEliminar, encabezadoBTClonar], TiposColMonitores, true);

  tabs := uInfoTabs.infoTabs.tabNames;
  Tabs.Add('?');
  TCActores.Tabs := tabs;
  SetLength(ListasDeActoresTabs, Tabs.Count);
  for i := 0 to Tabs.Count - 1 do
    ListasDeActoresTabs[i] := TListaDeCosasConNombre.Create(TCActores.Tabs[i]);

  listaMantenimientos := TListaMantenimientos.Create;

  // Hasta definir bien como se crea el monitor por defecto. Hay un MenuItem en el
  // menu de monitores que permite crearlo
  BCrearMonitorSimRes3PDefecto.Visible := False;

  utilidades.setTabOrderByTopAndLeft(self);
  intentarCargarDeParametros;
  self.BorderStyle := bsSizeable;

  {$IFNDEF INTERFACE_ADME}
  TSActoresV2.TabVisible := False;
  TSActores.TabVisible := True;
  {$ELSE}
  TSActoresV2.TabVisible := True;
  TSActores.TabVisible := False;
  {$ENDIF}

  {$IFDEF COMBUSTIBLES}
  TSCombustible.TabVisible:= true;
  {$ELSE}
  TSCombustible.TabVisible:= false;
  {$ENDIF}
end;

procedure TFSimSEEEdit.BAyudaEngancharClick(Sender: TObject);
begin
  //Nada aun
end;

procedure TFSimSEEEdit.btVerMantenimientosClick(Sender: TObject);
var
  nuevaListaMantenimientos: TListaMantenimientos;
  i, prueba: Integer;
  trx: TfrmDllForm;
  minAlturaX, maxAlturaX, minAlturaY, maxAlturaY,  NDivX, NDivY, jPaso, maxPuntos : Integer;
  fechaIni, fechaFin: TFecha;
  cuantosDiasDuraSimulacion: integer;
  nombresActores: TDAofString;
  esta: boolean;
  cuantosActoresPido: integer;
  colores: array of TColor;
begin
  nuevaListaMantenimientos := TListaMantenimientos.Create;

  //Creo colores

  setlength(colores, 12);
  colores[0]  := clBlue;
  colores[1]  := clOlive;
  colores[2]  := clTeal;
  colores[3]  := clGreen;
  colores[4]  := clNavy;
  colores[5]  := clPurple;
  colores[6]  := clBlack;
  colores[7]  := clGray;
  colores[8]  := clLime;
  colores[9]  := clFuchsia;
  colores[10] := clMaroon;
  colores[11] := clRed;


  nuevaListaMantenimientos.Init(sala.Gens);
  for i := 0 to sala.ComercioInternacional.Count - 1 do
      if not(TComercioInternacional(sala.ComercioInternacional[i]) is TContratoModalidadDevolucion) then
        nuevaListaMantenimientos.addActor(TComercioInternacional(sala.ComercioInternacional[i]));

  nuevaListaMantenimientos.sortByActorYFecha;

  //Pido los X primeros actores de mantenimientos
  cuantosActoresPido := 5;
  if (cuantosActoresPido) > 12 then
    cuantosActoresPido := 12;
  nombresActores := nuevaListaMantenimientos.getActorNameVector(cuantosActoresPido);

  /////////////////////////////////////////////////////////////////////

  //Creo el grafico
  trx := TfrmDllForm.Create(self);

  fechaIni := TFecha.Create_Clone(sala.globs.fechaIniSim);
  fechaFin := TFecha.Create_Clone(sala.globs.fechaFinSim);
  cuantosDiasDuraSimulacion := trunc(fechaIni.horasHasta(fechaFin)/24);


  minAlturaX := 0;
  maxAlturaX := cuantosDiasDuraSimulacion; //Escala en el eje x
  minAlturaY := 0;
  maxAlturaY := 2 * cuantosActoresPido + 1; //Escala en el eje y
  NDivX := 10;
  NDivY := 10;
  maxPuntos := 500;


  trx.CrearDiagramaXY(
      nombresActores[0], // Nombres
      maxPuntos,      // MaxNPuntos
      False,       // ciruclar
      'nombre_sx',         // nombre_sx
      nombresActores[0],  // nombre_sy1: pchar;
      colores[0],  //  color_sy1: TColor;
      minAlturaX, maxAlturaX,   //  x1, x2,
      minAlturaY, maxAlturaY, //y1, y2
      NDivX, NDivY        // NDivX, NDivY
      );

  trx.nilOnClose := @trx;

  trx.Show;

  //Creo las series para graficarlas
  for i := 1 to cuantosActoresPido-1 do
    trx.CrearSerieXY( nombresActores[i], maxPuntos, False, colores[i], TM_Cruz, colores[i], colores[i], 0);


  trx.dbj_gridx;
  trx.dbj_gridy;
  trx.dbj_borde;
  trx.titulo('Mantenimientos');
  trx.etiquetas_x(minAlturaX, maxAlturaX);
  trx.etiquetas_y(minAlturaY, maxAlturaY);
  trx.xlabel('PasoT');


  //Aca se imprimen los valores de cada serie
  for jPaso := 1 to cuantosDiasDuraSimulacion do
  begin
    trx.tr1.PlotNuevo_x(jPaso);

    for i := 0 to cuantosActoresPido -1 do
    begin

        //Tengo que buscar si esta
        esta := false;
        nuevaListaMantenimientos.buscarDisponibilidad(nombresActores[i], fechaIni, esta);

        //Solo grafico cuando esta disponible, sino no aporta nada
        if (esta) then
          trx.tr1.PlotNuevo_y(i+1, 2 * i + 1);

    end;


    fechaIni.addHoras(24);

  end;

end;

procedure TFSimSEEEdit.btVaciarCFAuxClick(Sender: TObject);
begin
  eArchiCFAux.Text := '';
end;

procedure TFSimSEEEdit.bt_VaciarCFEngancheClick(Sender: TObject);
begin
  RGLlenarUltimoFrame.ItemIndex := 0;
  RGLlenarUltimoFrameClick(Sender);
  eArchivoCF.Text:='';
end;

procedure TFSimSEEEdit.eArchiCFauxChange(Sender: TObject);
begin
    guardado := False;
end;

procedure TFSimSEEEdit.EArchivoCFChange(Sender: TObject);
begin
  guardado := False;
end;

procedure TFSimSEEEdit.registrarActores();
var
  info: TInfoCosaConNombre;
begin
  // El orden en que se registran los actores determina el orden en que aparecen en las
  // tabs

// Red
  info := TInfoCosaConNombre.Create(TNodo, TNodo.descClase, TEditarTNodo, nil);
  uInfoTabs.infoTabs.addInfoActor(info, strTabRed);

  info := TInfoCosaConNombre.Create(TArco, TArco.DescClase, TEditarTArco, TEditarFichaArco);
  uInfoTabs.infoTabs.addInfoActor(info, strTabRed);

// Demandas
  info := TInfoCosaConNombre.Create(TDemanda01, TDemanda01.DescClase, TEditarTDemanda01,
    TEditarFichaDemanda01);
  uInfoTabs.infoTabs.addInfoActor(info, strTabDemandas);
  info := TInfoCosaConNombre.Create(TDemandaDetallada, TDemandaDetallada.DescClase,
    TEditarTDemandaDetallada, nil);
  uInfoTabs.infoTabs.addInfoActor(info, strTabDemandas);
  info := TInfoCosaConNombre.Create(TDemandaAnioBaseEIndices, TDemandaAnioBaseEIndices.DescClase,
    TEditarTDemandaAnioBaseEIndices, nil);
  uInfoTabs.infoTabs.addInfoActor(info, strTabDemandas);



// Eólica
  info := TInfoCosaConNombre.Create(TParqueEolico, TParqueEolico.DescClase, TEditarTParqueEolico,    NIL);
  uInfoTabs.infoTabs.addInfoActor(info, strTabEolica);

  info := TInfoCosaConNombre.Create(
    TParqueEolico_vxy,
    TParqueEolico_vxy.DescClase, TEditarTParqueEolico_vxy,    NIL);
  uInfoTabs.infoTabs.addInfoActor(info, strTabEolica);



// Generadores Térmicos
  info := TInfoCosaConNombre.Create(TGTer_Basico, TGTer_Basico.DescClase, TEditarTGTer,
    TEditarFichaGTer_Basico);
  uInfoTabs.infoTabs.addInfoActor(info, strTabGeneradoresTermicos);
  info := TInfoCosaConNombre.Create(TGTer_OnOffPorPaso, TGTer_OnOffPorPaso.DescClase, TEditarTGTer,
    TEditarFichaGTer_OnOffPorPaso);
  uInfoTabs.infoTabs.addInfoActor(info, strTabGeneradoresTermicos);
  info := TInfoCosaConNombre.Create(TGTer_OnOffPorPoste, TGTer_OnOffPorPoste.DescClase,
    TEditarTGTer, TEditarFichaGTer_OnOffPorPoste);
  uInfoTabs.infoTabs.addInfoActor(info, strTabGeneradoresTermicos);
  info := TInfoCosaConNombre.Create(TGTer_ArranqueParada, TGTer_ArranqueParada.DescClase,
    TEditarTGter_ArranqueParada, TEditarFichaGTer_ArranqueParada);
  uInfoTabs.infoTabs.addInfoActor(info, strTabGeneradoresTermicos);
  info := TInfoCosaConNombre.Create(TGTer_Basico_TRep, TGTer_Basico_TRep.DescClase,
    TEditarTGTer_Basico_TRep, TEditarFichaGTer_Basico_TRep);
  uInfoTabs.infoTabs.addInfoActor(info, strTabGeneradoresTermicos);

  info:= TInfoCosaConNombre.Create(TGTer_Basico_PyCVariable,
    TGTer_Basico_PyCVariable.DescClase,
    TEditarTGTer_Basico_PyCVariable,
    TEditarFichaGTer_Basico_PyCVariable);
  uInfoTabs.infoTabs.addInfoActor(info, strTabGeneradoresTermicos);

  info := TInfoCosaConNombre.Create(TGTer_OnOffPorPaso_ConRestricciones,
    TGTer_OnOffPorPaso_ConRestricciones.DescClase,
    TEditarTGTer_OnOffPorPaso_ConRestricciones,
    TEditarFichaGTer_OnOffPorPaso_ConRestricciones);
  uInfoTabs.infoTabs.addInfoActor(info, strTabGeneradoresTermicos);

  info := TInfoCosaConNombre.Create(THidroConEmbalse, THidroConEmbalse.DescClase,
    TEditarTHidroConEmbalse, TEditarFichaHidroConEmbalse);
  uInfoTabs.infoTabs.addInfoActor(info, strTabGeneradoresHidraulicos);

  info := TInfoCosaConNombre.Create(THidroConBombeo, THidroConBombeo.DescClase,
    TEditarTHidroConBombeo, TEditarFichaHidroConBombeo);
  uInfoTabs.infoTabs.addInfoActor(info, strTabGeneradoresHidraulicos);

{$IFDEF FPC-LCL}
  info := TInfoCosaConNombre.Create(TGTer_combinado, TGTer_combinado.DescClase,
    TEditarTGTer_Combinado, TEditarFichaGTer_combinado);
  uInfoTabs.infoTabs.addInfoActor(info, strTabGeneradoresTermicos);
{$ENDIF}

{$IFDEF COMBUSTIBLES}
info := TInfoCosaConNombre.Create(TGTer_OnOffPorPosteV2, TGTer_OnOffPorPosteV2.DescClase,
  TEditarTGTerV2, TEditarFichaGTer_OnOffPorPosteV2);
uInfoTabs.infoTabs.addInfoActor(info, strTabGeneradoresTermicos);

info := TInfoCosaConNombre.Create(TGTer_OnOffPorPasoV2, TGTer_OnOffPorPasoV2.DescClase,
  TEditarTGTerV2, TEditarFichaGTer_OnOffPorPasoV2);
uInfoTabs.infoTabs.addInfoActor(info, strTabGeneradoresTermicos);

info := TInfoCosaConNombre.Create(TGTer_ArranqueParadaV2, TGTer_ArranqueParadaV2.DescClase,
  TEditarTGTerV2, TEditarFichaGTer_ArranqueParadaV2);
uInfoTabs.infoTabs.addInfoActor(info, strTabGeneradoresTermicos);

info := TInfoCosaConNombre.Create(TGTer_combinadoV2, TGTer_combinadoV2.DescClase,
  TEditarTGTerV2, TEditarFichaGTer_combinadoV2);
uInfoTabs.infoTabs.addInfoActor(info, strTabGeneradoresTermicos);
{$ENDIF}

// Generadores Hidráulicas
  { info:= TInfoActor.Create(THidroConEmbalseValorizado, THidroConEmbalseValorizado.DescClase, TAltaHidroConEmbalseValorizado, TEditarHidroConEmbalseValorizado, TEditarFichaHidroConEmbalseValorizado);
    uInfoTabs.infoTabs.addInfoActor(info, strTabGeneradoresHidraulicos); }
  info := TInfoCosaConNombre.Create(THidroDePasada, THidroDePasada.DescClase, TEditarTHidroDePasada,
    TEditarFichaHidroDePasada);
  uInfoTabs.infoTabs.addInfoActor(info, strTabGeneradoresHidraulicos);
  info := TInfoCosaConNombre.Create(THidroConEmbalseBinacional,
    THidroConEmbalseBinacional.DescClase, TEditarTHidroConEmbalseBinacional,
    TEditarFichaHidroConEmbalseBinacional);
  uInfoTabs.infoTabs.addInfoActor(info, strTabGeneradoresHidraulicos);

// Comercio Internacional
  info := TInfoCosaConNombre.Create(TMercadoSpot, TMercadoSpot.DescClase, TEditarTBaseMercadoSpot,
    TEditarFichaMercadoSpot);
  uInfoTabs.infoTabs.addInfoActor(info, strTabComercioInternacional);
  info := TInfoCosaConNombre.Create(TMercadoSpotDetalleHorarioSemanal,
    TMercadoSpotDetalleHorarioSemanal.DescClase, TEditarTBaseMercadoSpot,
    TEditarFichaMercadoSpotConDetalleHorario);
  uInfoTabs.infoTabs.addInfoActor(info, strTabComercioInternacional);
  info := TInfoCosaConNombre.Create(TContratoModalidadDevolucion,
    TContratoModalidadDevolucion.DescClase, TEditarTContratoModalidadDevolucion,
    TEditarFichaContratoModalidadDevolucion);
  uInfoTabs.infoTabs.addInfoActor(info, strTabComercioInternacional);

{$IFDEF FPC-LCL}
  info := TInfoCosaConNombre.Create(TMercadoSpot_postizado,
    TMercadoSpot_postizado.DescClase, TEditarTMercadoSpot_postizado,
    TEditarFichaMercadoSpot_postizado);
  uInfoTabs.infoTabs.addInfoActor(info, strTabComercioInternacional);
{$ENDIF}

  uInfoTabs.infoTabs.crearOrdinales;
end;

procedure TFSimSEEEdit.registrarMonitores;
begin
  uInfoCosa.InfoMonitores.Add(TInfoCosa.Create(TReferenciaMonConsola,
      TReferenciaMonConsola.DescClase, TAltaMonitorConsola));
  uInfoCosa.InfoMonitores.Add(TInfoCosa.Create(TReferenciaMonGrafico,
      TReferenciaMonGrafico.DescClase, TAltaMonitorGrafico));
  uInfoCosa.InfoMonitores.Add(TInfoCosa.Create(TReferenciaMonArchivo,
      TReferenciaMonArchivo.DescClase, TAltaMonArchivo));
  uInfoCosa.InfoMonitores.Add(TInfoCosa.Create(TReferenciaMonHistograma,
      TReferenciaMonHistograma.DescClase, TAltaMonitorHistograma));
  uInfoCosa.InfoMonitores.Add(TInfoCosa.Create(TReferenciaMonSimRes,
      TReferenciaMonSimRes.DescClase, TAltaMonSimRes));
end;

procedure TFSimSEEEdit.RGLlenarUltimoFrameClick(Sender: TObject);
begin
  if RGLlenarUltimoFrame.ItemIndex = 0 then
  begin
    if sala.usarArchivoParaInicializarFrameInicial then
    begin
      sala.usarArchivoParaInicializarFrameInicial := False;
      EArchivoCF.Enabled := False;
      BBuscarArchivoCF.Enabled := False;
      BEnganches.Enabled := False;
    end;
  end
  else
  begin
    if not sala.usarArchivoParaInicializarFrameInicial then
    begin
      sala.usarArchivoParaInicializarFrameInicial := True;
      EArchivoCF.Enabled := True;
      BBuscarArchivoCF.Enabled := True;
      BEnganches.Enabled := True;
    end;
  end;
  guardado := False;
end;

procedure TFSimSEEEdit.registrarCombustibles;
begin
  uInfoCosa.InfoCombustibles.Add(TInfoCosa.Create(TCombustible, TCombustible.DescClase, TEditarTCombustible  ));
  uInfoCosa.InfoFichasCombustibles.Add(TInfoCosa.Create(TFichaCombustible,
      TFichaCombustible.DescClase, TEditarFichaCombustible));
end;

procedure TFSimSEEEdit.registrarFuentes;
begin
  uInfoCosa.InfoFuentes.Add(TInfoCosa.Create(TFuenteConstante, TFuenteConstante.DescClase,
      TEditarFuentesSimples));
  uInfoCosa.InfoFichasFuentes.Add(TInfoCosa.Create(TFichaFuenteConstante,
      TFichaFuenteConstante.DescClase, TEditarFichaFuenteConstante));
  uInfoCosa.InfoFuentes.Add(TInfoCosa.Create(TFuenteUniforme, TFuenteUniforme.DescClase,
      TEditarFuentesSimples));
  uInfoCosa.InfoFichasFuentes.Add(TInfoCosa.Create(TFichaFuenteUniforme,
      TFichaFuenteUniforme.DescClase, TEditarFichaFuenteUniforme));
  uInfoCosa.InfoFuentes.Add(TInfoCosa.Create(TFuenteGaussiana, TFuenteGaussiana.DescClase,
      TEditarFuentesSimples));
  uInfoCosa.InfoFichasFuentes.Add(TInfoCosa.Create(TFichaFuenteGaussiana,
      TFichaFuenteGaussiana.DescClase, TEditarFichaFuenteGaussiana));
  uInfoCosa.InfoFuentes.Add(TInfoCosa.Create(TFuenteWeibull, TFuenteWeibull.DescClase,
      TEditarFuentesSimples));
  uInfoCosa.InfoFichasFuentes.Add(TInfoCosa.Create(TFichaFuenteWeibull,
      TFichaFuenteWeibull.DescClase, TEditarFichaFuenteWeibull));
  uInfoCosa.InfoFuentes.Add(TInfoCosa.Create(TFuenteCombinacion,
      TFuenteCombinacion.DescClase, TEditarFuentesSimples));
  uInfoCosa.InfoFichasFuentes.Add(TInfoCosa.Create(TFichaFuenteCombinacion,
      TFichaFuenteCombinacion.DescClase, TEditarFichaFuenteCombinacion));
  uInfoCosa.InfoFuentes.Add(TInfoCosa.Create(TFuenteProducto, TFuenteProducto.DescClase,
      TEditarFuentesSimples));
  uInfoCosa.InfoFichasFuentes.Add(TInfoCosa.Create(TFichaFuenteProducto,
      TFichaFuenteProducto.DescClase, TEditarFichaFuenteProducto));

  uInfoCosa.InfoFuentes.Add(TInfoCosa.Create(TFuenteSintetizadorCEGH,
      TFuenteSintetizadorCEGH.DescClase, TEditarFuenteSintetizador));

{$IFDEF FPC-LCL}
  uInfoCosa.InfoFuentes.Add(TInfoCosa.Create(TFuenteTiempo,
      TFuenteTiempo.DescClase, TEditarFuentesSimples));
  uInfoCosa.InfoFichasFuentes.Add(TInfoCosa.Create(TFichaFuenteTiempo,
    TFichaFuenteTiempo.DescClase, TEditarFichaFuenteTiempo));

  uInfoCosa.InfoFuentes.Add(TInfoCosa.Create(TFuenteSinusoide,
      TFuenteSinusoide.DescClase, TEditarFuentesSimples));
  uInfoCosa.InfoFichasFuentes.Add(TInfoCosa.Create(TFichaFuenteSinusoide,
    TFichaFuenteSinusoide.DescClase, TEditarFichaFuenteSinusoide));

  uInfoCosa.InfoFuentes.Add(TInfoCosa.Create(TFuenteMaxMin,
      TFuenteMaxMin.DescClase, TEditarFuentesSimples));
  uInfoCosa.InfoFichasFuentes.Add(TInfoCosa.Create(TFichaFuenteMaxMin,
    TFichaFuenteMaxMin.DescClase, TEditarFichaFuenteMaxMin));
{$ENDIF}
end;

{ procedure TFSimSEEEdit.cargarDatosListadoMantenimiento;
  var
  i, anioIni, anioFin: Integer;
  begin
  sgMantenimientos.RowCount:= sala.listaActores.Count + 4;
  if sgMantenimientos.RowCount > 1 then
  sgMantenimientos.FixedRows:= 1;

  for i:= 0 to sala.listaActores.Count -1 do
  sgMantenimientos.Cells[0, i + 1]:= TCosaConNombre(sala.listaActores[i]).ClaseNombre;

  sgMantenimientos.Cells[0, sgMantenimientos.RowCount - 3]:= 'Demanda Firme[MW]';
  sgMantenimientos.Cells[0, sgMantenimientos.RowCount - 2]:= 'Capacidad Firme de Generación[MW]';
  sgMantenimientos.Cells[0, sgMantenimientos.RowCount - 1]:= 'Diferencia[MW]';

  utilidadesPresentacion.AutoSizeCol(sgMantenimientos, 0);
  utilidadesPresentacion.AutoSizeTable(sbMantenimientos, sgMantenimientos, maxAnchoTablaEnorme, maxAlturaTablaEnorme);
  if sgMantenimientos.Width > TSMantenimiento.ClientWidth then
  sbMantenimientos.Width:= TSMantenimiento.ClientWidth
  else
  sbMantenimientos.Width:= sgMantenimientos.Width +5;

  anioIni:= Sala.globs.fechaIni.getAnio;
  anioFin:= Sala.globs.fechaFin.getAnio;

  CBAnioMantenimiento.Items.Clear;
  for i:= anioIni to anioFin do
  CBAnioMantenimiento.Items.Add(IntToStr(i));
  CBAnioMantenimiento.ItemIndex:= 0;

  actualizarAnioTablaMantenimiento(anioIni);
  end;

  procedure TFSimSEEEdit.actualizarAnioTablaMantenimiento(anio: Integer);
  var
  i, primerSemana, ultimaSemana: Integer;
  begin
  if anio = Sala.globs.fechaIni.getAnio then
  primerSemana:= sala.globs.fechaIni.semana
  else
  primerSemana:= 1;
  if anio = Sala.globs.fechaFin.getAnio then
  if sala.globs.fechaIni.HorasHasta(Sala.globs.fechaFin) mod sala.globs.HorasDelPaso = 0 then
  ultimaSemana:= Sala.globs.fechaFin.semana -1
  else
  ultimaSemana:= Sala.globs.fechaFin.semana
  else
  ultimaSemana:= 52;

  for i:= 1 to primerSemana - 1 do
  begin
  sgMantenimientos.Cells[i, 0]:= '';
  TiposColMantenimientos[i]:= TC_Disabled;
  end;

  for i:= ultimaSemana + 1 to 53 do
  begin
  TiposColMantenimientos[i]:= TC_Disabled;
  sgMantenimientos.Cells[i, 0]:= '';
  end;
  sgMantenimientos.Invalidate;
  actualizarTablaMantenimiento(primerSemana, ultimaSemana);
  end;

  procedure TFSimSEEEdit.actualizarTablaMantenimiento(primerSemana, ultimaSemana: Integer);
  var
  i, j, anio, nMaqs: Integer;
  fechaIni, fechaFin: TFecha;
  actor: TActor;
  demanda, generacion, dif: NReal;
  paso: Integer;
  begin
  anio:= StrToInt(CBAnioMantenimiento.Text);

  fechaIni:= TFecha.Create_AnioSemana(anio, primerSemana);
  fechaFin:= TFecha.Create_AnioSemana(anio, primerSemana + 1);
  paso:= 1;
  try
  begin
  Sala.globs.HorasDelPaso:= 168;
  for i:= primerSemana to ultimaSemana do
  begin
  sgMantenimientos.Cells[i, 0]:= IntToStr(i);
  TiposColMantenimientos[i]:= TC_TextoEditable;

  paso:= prepararSala(fechaIni, paso, 168);

  for j:= 0 to sala.listaActores.Count -1 do
  begin
  actor:= TActor(sala.listaActores[j]);
  nMaqs:= actor.paUnidades.nUnidades;
  sgMantenimientos.Cells[i, j + 1]:= IntToStr(nMaqs)
  end;

  demanda:= demandaFirme(sala);
  sgMantenimientos.Cells[i, sgMantenimientos.RowCount - 3]:= FloatToStrF(demanda, ffGeneral, 5, 0);
  generacion:= potenciaFirme(sala);
  sgMantenimientos.Cells[i, sgMantenimientos.RowCount - 2]:= FloatToStrF(generacion, ffGeneral, 5, 0);
  dif:= generacion - demanda;
  sgMantenimientos.Cells[i, sgMantenimientos.RowCount - 1]:= FloatToStrF(dif, ffGeneral, 5, 0);

  fechaIni.addHoras(168);
  fechaFin.addHoras(168);
  end;
  end
  except
  On e: Exception do
  manejarExcepcionPrepararSala(e);
  end;
  fechaIni.free;
  fechaFin.free;
  end;

  procedure TFSimSEEUEdit.modificarMantenimiento;
  var
  fechaAux: TFecha;
  i: Integer;
  begin
  with CBMantenimientos do
  begin
  Clear;
  fechaAux:= TFecha.Create_AnioSemana(StrToInt(CBAnioMantenimiento.text), sgMantenimientos.Selection.BottomRight.X);
  for i:= 0 to (IGenerador(listaMantenimiento.lst[sgMantenimientos.Selection.TopLeft.Y - 1])).maqsFueraDeMantenimiento(fechaAux) do
  items.Add(IntToStr(i));
  fechaAux.Free;
  end;
  utilidadesPresentacion.PopUpComboBox(sgMantenimientos, CBMantenimientos);
  end; }

procedure TFSimSEEEdit.LimpiarSala;
var
  i: integer;
begin
  Sala.Free;
  uCosaConNombre.LimpiarReferencias;
  for i := 0 to high(ListasDeActoresTabs) do
    ListasDeActoresTabs[i].Clear;
  Sala := nil;
end;

procedure TFSimSEEEdit.LimpiarManejadorMonitores;
begin
  manejadorMonitores.Free;
  manejadorMonitores := nil;
end;


function TFSimSEEEdit.editarMantenimiento(fila: integer; clonar: boolean): integer;
var
  form: TEditarFichaUnidades;
  formSelectActor: TFormSelectTipo;
  nombresActoresConMantenimiento: TStringList;
  actor: TActor;
  ficha: TFichaUnidades;
  editar: boolean;
  res: Integer;
  i: Integer;
begin
  res := -1;
  if fila = 0 then
  begin
    nombresActoresConMantenimiento := TStringList.Create;
    nombresActoresConMantenimiento.Sorted := true;
    nombresActoresConMantenimiento.Duplicates := dupIgnore;
    for i := 0 to listaMantenimientos.Count - 1 do
      nombresActoresConMantenimiento.Add(TNodoListaMantenimientos(listaMantenimientos.Items[i]).actor.nombre);

    formSelectActor := TFormSelectTipo.Create(self, rsSeleccioneUnGenerador, nombresActoresConMantenimiento);
    if formSelectActor.ShowModal = mrOk then
    begin
      actor := TActor(sala.listaActores.find(formSelectActor.darTipo));
      editar := True;
    end
    else
    begin
      actor := NIL; // para evitar el warning
      editar := False;
    end;

    ficha := nil;
    formSelectActor.Free;
    nombresActoresConMantenimiento.Free;
  end
  else
  begin
    actor := TNodoListaMantenimientos(listaMantenimientos[fila - 1]).actor;
    ficha := TNodoListaMantenimientos(listaMantenimientos[fila - 1]).fichaUnidades;
    editar := True;
  end;

  if editar then
  begin
    form := TEditarFichaUnidades.Create(self, actor, ficha, nil);
    if form.ShowModal = mrOk then
    begin
      if not clonar then
      begin
        if ficha <> NIL then // Si no estoy agregando una ficha nueva
        begin
          TNodoListaMantenimientos(listaMantenimientos[fila - 1]).Free;
          listaMantenimientos.Delete(fila - 1);
          actor.lpdUnidades.replace(ficha, form.darFicha);
          ficha.Free;
        end
        else
          actor.lpdUnidades.Add(form.darFicha);
      end;
      res := listaMantenimientos.addInOrderByActorYFecha(actor,
        TFichaUnidades(form.darFicha())) + 1;
      actualizarTablaMantenimientos;
      guardado := False;
    end;
    form.Free;
  end
  else
    res := -1;
  Result := res;
end;

procedure TFSimSEEEdit.eliminarMantenimiento(fila: integer);
var
  nodo: TNodoListaMantenimientos;
  texto: string;
begin
  nodo := listaMantenimientos[fila - 1];
  if nodo.actor.lpdUnidades.Count = 1 then
  begin
    ShowMessage(
      mesNoSePuedeEliminarLaFichaDeUnidades);
  end
  else
  begin
    texto :=
      mesConfirmaEliminarFichaUnidadesActor + nodo.actor.nombre +
      '" para el ' + nodo.fichaUnidades.fecha.AsStr + '?';
    if (Application.MessageBox(PChar(texto), pchar(mesConfirmarEliminacion),
        MB_OKCANCEL + MB_ICONEXCLAMATION) = IDOK) then
    begin
      nodo.actor.lpdUnidades.Remove(nodo.fichaUnidades);
      nodo.fichaUnidades.Free;
      nodo.Free;
      listaMantenimientos.Delete(fila - 1);
      actualizarTablaMantenimientos;
      guardado := False;
    end
  end;
end;

procedure TFSimSEEEdit.altaMantenimiento;
begin
  editarMantenimiento(0, False);
end;

procedure TFSimSEEEdit.actualizarTablaMantenimientos;
var
  i: Integer;
  aux: TNodoListaMantenimientos;
begin
  sgMantenimientos.RowCount := listaMantenimientos.Count + 1;
  if sgMantenimientos.RowCount > 1 then
    sgMantenimientos.FixedRows := 1
  else
    sgLimpiarSeleccion(sgMantenimientos);

  for i := 0 to listaMantenimientos.Count - 1 do
  begin
    aux := TNodoListaMantenimientos(listaMantenimientos[i]);
    sgMantenimientos.Cells[0, i + 1] := aux.actor.nombre;
    sgMantenimientos.Cells[1, i + 1] := aux.actor.DescClase;
    sgMantenimientos.Cells[2, i + 1] := aux.fichaUnidades.fecha.AsStr;
    sgMantenimientos.Cells[3, i + 1] := IntToStr(aux.fichaUnidades.nUnidades[0]);
    sgMantenimientos.Cells[4, i + 1] := boolToSiNo(aux.fichaUnidades.periodicidad <> nil);
  end;

  for i := 0 to sgMantenimientos.ColCount - 1 do
    utilidades.AutoSizeTypedCol(sgMantenimientos, i, TiposColMantenimientos[i], iconos);
  utilidades.AutosizeTable(TSMantenimientos, sgMantenimientos, maxAnchoTablaEnorme,
    maxAlturaTablaGrande, TSimSEEEditOptions.getInstance.
      deshabilitarScrollHorizontalEnListados);
  BAgregarFichaUnidades.Left := (sgMantenimientos.Left + sgMantenimientos.Width)
    - BAgregarFichaUnidades.Width;
end;

function TFSimSEEEdit.validarCeldaMantenimientos(listado: TStringGrid;
  fila, columna: integer): boolean;
begin
  case columna of
    2:
      Result := inherited validarCeldaFecha(listado, fila, columna);
    3:
      Result := inherited validarCeldaNInt(listado, fila, columna);
  else
      Result := True;
  end;
end;

procedure TFSimSEEEdit.cambioValorMantenimientos(listado: TStringGrid;
  fila, columna: integer);
var
  aux: TNodoListaMantenimientos;
begin
  if columna = 2 then
  begin
    aux := TNodoListaMantenimientos(listaMantenimientos[fila - 1]);
    aux.fichaUnidades.fecha.Free;
    aux.fichaUnidades.fecha := FSimSEEEdit.StringToFecha(listado.Cells[columna, fila]);
    guardado := False;
    listaMantenimientos.sortByActorYFecha;
    actualizarTablaMantenimientos;
    sgMantenimientos.Row := listaMantenimientos.IndexOf(aux) + 1;
  end
  else if columna = 3 then
  begin
    TNodoListaMantenimientos(listaMantenimientos[fila - 1]).fichaUnidades.nUnidades[0] :=
      StrToInt(listado.Cells[columna, fila]);
    guardado := False;
  end;
end;


procedure TFSimSEEEdit.editarMonitor(fila: integer; clonar: boolean);
var
  form: TBaseAltasMonitores;
  TipoEditor: TClaseEditoresMonitores;
  monitor, nuevoMonitor: TReferenciaMonitor;
begin
  monitor := TReferenciaMonitor(manejadorMonitores.referenciasMonitores[fila - 1]);
  TipoEditor := TClaseEditoresMonitores(uInfoCosa.InfoMonitores.getTipoEditor
      (monitor.ClassType));
  if TipoEditor <> nil then
  begin
    form := TipoEditor.Create(self, monitor, sala, manejadorMonitores, clonar,
      TClaseReferenciaMonitor(monitor.ClassType));
    if form.ShowModal = mrOk then
    begin
      nuevoMonitor := form.darReferenciaMonitor;
      if manejadorMonitores.notificarCambioCosa(monitor, nuevoMonitor) then
        guardadoMonitores := False;
      if not clonar then
      begin
        manejadorMonitores.quitarMonitor(monitor);
        manejadorMonitores.referenciasMonitores.Remove(monitor);
        monitor.Free;
      end;
      manejadorMonitores.referenciasMonitores.Add(nuevoMonitor);
      actualizarTablaMonitores;
      sgBuscarYSeleccionarFila(sgMonitores, 0, nuevoMonitor.nombre);
      manejadorMonitores.PrepararseYPubliVars;
      guardadoMonitores := False;
    end;
    form.Free;
  end
  else
  begin
    raise Exception.Create(exEditorNoRegistradoClase + monitor.ClassName);
  end
end;

procedure TFSimSEEEdit.eliminarMonitor(fila: integer);
var
  monitor: TReferenciaMonitor;
  texto: String;
begin
  monitor := TReferenciaMonitor(manejadorMonitores.referenciasMonitores[fila - 1]);
  texto := mesConfirmaEliminarMonitor + monitor.nombre + '"?';
  if (Application.MessageBox(PChar(texto), pchar(mesConfirmarEliminacion),
      MB_OKCANCEL + MB_ICONEXCLAMATION) = IDOK) then
  begin
    manejadorMonitores.referenciasMonitores.Delete(fila - 1);
    monitor.Free;
    actualizarTablaMonitores;
    guardadoMonitores := False;
  end
end;

procedure TFSimSEEEdit.altaMonitor;
var
  form: TBaseAltasMonitores;
  formSelectTipo: TFormSelectTipo;
  tipoEditorMonitor: TClaseEditoresMonitores;
  tipoReferencia: TClaseReferenciaMonitor;
begin
  // Selecciono el tipo de monitor
  formSelectTipo := TFormSelectTipo.Create(self, uInfoCosa.InfoMonitores.descsClase);
  if formSelectTipo.ShowModal = mrOk then
  begin
    tipoReferencia := TClaseReferenciaMonitor(uInfoCosa.InfoMonitores.tipoDeCosa
        (formSelectTipo.darTipo));
    tipoEditorMonitor := TClaseEditoresMonitores(uInfoCosa.InfoMonitores.getTipoEditor
        (tipoReferencia));
    formSelectTipo.Free;

    // Muestro el editor del monitor seleccionado
    form := tipoEditorMonitor.Create(self, NIL, sala, manejadorMonitores, true,
      tipoReferencia);
    if form.ShowModal = mrOk then
    begin
      manejadorMonitores.referenciasMonitores.Add(form.darReferenciaMonitor);
      actualizarTablaMonitores;
      manejadorMonitores.PrepararseYPubliVars;
      sgBuscarYSeleccionarFila(sgMonitores, 0, form.darReferenciaMonitor.nombre);
      guardadoMonitores := False;
    end;
    form.Free;
  end;
end;

procedure TFSimSEEEdit.actualizarTablaMonitores;
var
  i: Integer;
  aux: TReferenciaMonitor;
begin
  sgMonitores.RowCount := manejadorMonitores.referenciasMonitores.Count + 1;
  if sgMonitores.RowCount > 1 then
    sgMonitores.FixedRows := 1
  else
    sgLimpiarSeleccion(sgMonitores);

  for i := 0 to manejadorMonitores.referenciasMonitores.Count - 1 do
  begin
    aux := TReferenciaMonitor(manejadorMonitores.referenciasMonitores[i]);
    sgMonitores.Cells[0, i + 1] := aux.nombre;
    sgMonitores.Cells[1, i + 1] := aux.DescClase;
    if aux.Enabled then
      sgMonitores.Cells[2, i + 1] := '1'
    else
      sgMonitores.Cells[2, i + 1] := '';
  end;

  for i := 0 to sgMonitores.ColCount - 1 do
    utilidades.AutoSizeTypedCol(sgMonitores, i, TiposColMonitores[i], iconos);
  utilidades.AutosizeTable(TSMonitores, sgMonitores, maxAnchoTablaEnorme,
    maxAlturaTablaGrande, TSimSEEEditOptions.getInstance.
      deshabilitarScrollHorizontalEnListados);
  BAgregarMonitor.Left := (sgMonitores.Left + sgMonitores.Width) - BAgregarMonitor.Width;
  BCrearMonitorSimRes3PDefecto.Left := BAgregarMonitor.Left -
    BCrearMonitorSimRes3PDefecto.Width - 10;
end;

procedure TFSimSEEEdit.crearMonitorSimResPorDefecto;
var
  newMonSimRes, oldMonSimRes: TReferenciaMonSimRes;
begin
  newMonSimRes := manejadorMonitores.crearMonitorSimResPorDefecto;

  oldMonSimRes := TReferenciaMonSimRes(manejadorMonitores.referenciasMonitores.find
      (nomMonSimRes3PDefecto));
  if oldMonSimRes = nil then
  begin
    manejadorMonitores.referenciasMonitores.Add(newMonSimRes);
    actualizarTablaMonitores;
  end
  else
  begin
    if Application.MessageBox(pchar(mesMonitorXDefectoCreadoRemplazarlo),
      PChar(mesRemplazarMonitorSimRes3), MB_YESNO + MB_ICONQUESTION) = idYes then
    begin
      manejadorMonitores.referenciasMonitores.replace(oldMonSimRes, newMonSimRes);
      oldMonSimRes.Free;
      actualizarTablaMonitores;
    end;
  end;
end;

procedure TFSimSEEEdit.validarCambioTablaPostes(tabla: TStringGrid);
var
  i: integer;
  DurPaso: NReal;
begin
  if (colValidarSG <> -1) and (filaValidarSG <> -1) then
  begin
    if (tabla.Cells[colValidarSG, filaValidarSG] <> loQueHabia) and
      (filaValidarSG > tabla.FixedRows - 1) and (colValidarSG > tabla.FixedCols - 1) then
      try
        if colValidarSG - 1 < Length(Sala.globs.DurPos) then
          sala.globs.DurPos[colValidarSG - 1] := StrToFloat(tabla.Cells[colValidarSG,
            filaValidarSG]);
        DurPaso := 0;
        for i := 0 to Sala.globs.NPostes - 1 do
          DurPaso := DurPaso + Sala.globs.DurPos[i];

        EDurPaso.Text := FloatToStr(DurPaso);
        guardado := false;
      except
        on EConvertError do
        begin
          tabla.Cells[tabla.col, tabla.Row] := loQueHabia;
          ShowMessage(mesValorIntroducidoDebeNum);
        end
      end
  end
end;

procedure TFSimSEEEdit.EditTamTablaExit(Sender: TObject);
var
  nAnt, n, i: integer;
  DurPaso: Integer;
begin
  if validarEditInt(TEdit(Sender), 1, MAXINT) then
  begin
    nAnt := sgPostes.ColCount - 1;
    n := StrToInt(TEdit(Sender).Text);
    if n <> nAnt then
    begin
      sgPostes.ColCount := n + 1;
      Sala.globs.NPostes := n;

      setLength(Sala.globs.durpos, n);
      for i := nAnt + 1 to n do
      begin
        sgPostes.Cells[i, 0] := IntToStr(i);
        sgPostes.Cells[i, 1] := sgPostes.Cells[nAnt, 1];
      end;

      DurPaso := 0;
      for i := 1 to n do
        DurPaso := DurPaso + StrToInt(sgPostes.Cells[i, 1]);
      EDurPaso.Text := IntToStr(DurPaso);

      for i := 0 to n - 1 do
        Sala.globs.DurPos[i] := StrToFloat(sgPostes.cells[i + 1, 1]);

      utilidades.AutoSizeTable(TSGlobales, sgPostes, maxAnchoTablaEnorme,
        maxAlturaTablaChica,
        TSimSEEEditOptions.getInstance.deshabilitarScrollHorizontalEnListados);
      recalcNumeroPasos(Sender);

      Sala.PrepararseYPubliVars;

      guardado := False;
    end
  end
end;

procedure TFSimSEEEdit.FormDestroy(Sender: TObject);
begin
  if manejadorListadoEditores <> NIL then
    manejadorListadoEditores.Free;
  if observadorCambiosEditoresActores <> NIL then
    observadorCambiosEditoresActores.Free;
  inherited;
end;

procedure TFSimSEEEdit.MNuevoClick(Sender: TObject);
var
  hacerNuevo: boolean;
  mbResult: Integer;
begin
  hacerNuevo := guardado;
  if not guardado then
  begin
    mbResult := Application.MessageBox(
      pchar(mesSalaNoGuardadaGuardarCambios), PChar(mesSimSEEEdit),
      MB_YESNOCANCEL or MB_ICONEXCLAMATION);
    if mbResult = idYes then
    begin
      MGuardarClick(MGuardar);
      hacerNuevo := guardado;
      Sala.globs.abortarSim := guardado;
    end
    else if mbResult = idNo then
    begin
      Sala.globs.abortarSim := True;
      hacerNuevo := true
    end
    else
    begin
      hacerNuevo := False;
    end
  end;
  if hacerNuevo then
  begin
    if Sala <> nil then
      LimpiarSala;
    crearSalaIni;
    MemoWarnings.Clear;
    Init;
    self.Caption := 'Editor - SimSEE - v' + uversiones.vSimSEEEdit + ' ( IIE-FING )';
  end
end;

{ procedure TFSimSEEEdit.eliminarFuncionesPrivadasNoReferenciadas;
  var
  i: Integer;
  func: TFuncion;
  aux: TSalaDeJuego;
  begin
  assert(uCosaConNombre.referenciasSinResolver = 0);
  aux:= TSalaDeJuego(sala.Create_Clone);
  for i:= 0 to sala.Funcs.Count - 1 do
  begin
  func:= TFuncion(sala.Funcs[i]);
  if not func.publica and not existeReferencia_al(func) then
  begin
  sala.Funcs[i]:= NIL;
  func.Free;
  end;
  end;
  sala.Funcs.Pack;
  aux.Free;
  LimpiarReferencias;
  end; }

procedure TFSimSEEEdit.intentarCargarDeParametros;
begin
  if ParamCount > 0 then
  begin
    if FileExists(ParamStr(1)) { *Converted from FileExists*  } then
    begin
      DCargarSala.FileName := ParamStr(1);
      if ParamCount > 1 then
      begin
        if FileExists(ParamStr(2)) { *Converted from FileExists*  } then
        begin
          DCargarManejadorMonitores.FileName := ParamStr(2);
          DSalvarManejadorMonitores.FileName := DCargarManejadorMonitores.FileName;
        end
        else
          msgAdvertenciaCargandoDeArchivo
            (mesNoSeEncuentraArchivoMonitores + ParamStr(2));
      end;
      abrir;
    end
    else
      msgErrorCargandoDeArchivo(mesNoSeEncuentraSalaDeJuego + ParamStr(1));
  end
end;


procedure TFSimSEEEdit.crearSalaIni();
var
  DurPos: TDAofNReal;
begin
  nErroresCargando := 0;
  DCargarSala.FileName := '';
  DSalvarSala.FileName := '';
  DCargarManejadorMonitores.FileName := '';
  DSalvarManejadorMonitores.FileName := '';

  setLength(DurPos, 3);

  durpos[0] := 4;
  durpos[1] := 10;
  durpos[2] := 10;

  Sala := TSalaDeJuego.Create('Sala', StringToFecha('01/01/2009'),
    StringToFecha('01/01/2011'), StringToFecha('01/01/2009'),
    StringToFecha('01/01/2011'), DurPos);

  sala.globs.SortearOpt := false;
  Sala.globs.NCronicasOpt := 20;
  Sala.globs.NCronicasSim := 100;
  Sala.globs.TasaDeActualizacion := 0.12;

  manejadorMonitores := TManejadoresDeMonitores.Create(self.sala);
end;

procedure TFSimSEEEdit.abrir();
var
  f: TarchiTexto;
  mbResult: integer;
begin
  if Sala <> nil then
    LimpiarSala;
  nErroresCargando := 0;
  MemoWarnings.Clear;

  chdir( extractFilePath( DCargarSala.FileName ));
  f := TArchiTexto.CreateForRead(DCargarSala.FileName, False);
  try
    f.rd('sala', TCosa(sala));
  finally
    f.Free;
  end;

  if sala = nil then
    raise Exception.Create(exNoFuePosibleLeerSala);

  sala.setDirCorrida(DCargarSala.FileName);
  if uSalasdejuegoParaEditor.resolverReferenciasContraSala(sala, False) > 0 then
  begin
    MessageDlg('No se pudo resolver todas las asociaciones entre los actores' +
        ' de la sala, por lo que no se cargará. Puede ver la lista de ' +
        'referencias que no pudieron resolverse en el siguiente ' + 'archivo: ' +
        getDir_Run + 'errRefs.txt', mtError, [mbOK], 0);
    uCosaConNombre.DumpReferencias(getDir_Run + 'errRefs.txt');
    LimpiarSala;
    LimpiarReferencias;
    Init;
    Exit;
  end;

  if not guardadoMonitores then
  begin
    mbResult := Application.MessageBox(
      pchar(mesMonitoresNoGuardadosGuardarCambios), PChar(mesSimSEEEdit),
      MB_YESNOCANCEL or MB_ICONEXCLAMATION);
    if mbResult = idYes then
      guardarMonitores;
  end;
  if manejadorMonitores <> nil then
  begin
    LimpiarManejadorMonitores;
    DCargarManejadorMonitores.FileName := '';
    DSalvarManejadorMonitores.FileName := '';
  end;

  if FileExists(utilidades.titulo(DCargarSala.FileName) + '.mon') { *Converted from FileExists*  } then
  begin
    DCargarManejadorMonitores.FileName := utilidades.titulo(DCargarSala.FileName) + '.mon';
    DSalvarManejadorMonitores.FileName := DCargarManejadorMonitores.FileName;
    abrirMonitores;
  end
  else
    manejadorMonitores := TManejadoresDeMonitores.Create(sala);

  Init;
  DSalvarSala.FileName := DCargarSala.FileName;
  self.Caption := 'Editor - SimSEE - v' + uversiones.vSimSEEEdit + ' ( IIE - FING ) - ' +
    DCargarSala.FileName;

  cargarListados;

  if nErroresCargando > 0 then
    ShowMessage(
      mesArchivoSalaContieneErrores + #10 +
      mesSeLogroCargarSalaConProblemas + #10 +
      mesAntesDeGuardarAsegureseContieneTodaInfo);
end;

procedure TFSimSEEEdit.cargarListados;
var
  TipoActor: TClass;
  i, indiceTab: integer;
begin
  // Limpio lo que hubiera
  for i := 0 to high(ListasDeActoresTabs) do
    ListasDeActoresTabs[i].Clear;

  // Agrego los nodos a los listados
  if Sala.Nods.Count > 0 then
  begin
    TipoActor := TActor(Sala.Nods[0]).ClassType;
    indiceTab := uInfoTabs.infoTabs.indiceTabDeTipo(TipoActor);
    for i := 0 to Sala.Nods.Count - 1 do
    begin
      if TipoActor <> TActor(Sala.Nods[i]).ClassType then
      begin
        TipoActor := TActor(Sala.Nods[i]).ClassType;
        indiceTab := uInfoTabs.infoTabs.indiceTabDeTipo(TipoActor);
      end;
      ListasDeActoresTabs[indiceTab].Add(TActor(Sala.Nods[i]));
    end
  end;

  // Agrego las Demandas a los listados
  if Sala.Dems.Count > 0 then
  begin
    TipoActor := TActor(Sala.Dems[0]).ClassType;
    indiceTab := uInfoTabs.infoTabs.indiceTabDeTipo(TipoActor);
    for i := 0 to Sala.Dems.Count - 1 do
    begin
      if TipoActor <> TActor(Sala.Dems[i]).ClassType then
      begin
        TipoActor := TActor(Sala.Dems[i]).ClassType;
        indiceTab := uInfoTabs.infoTabs.indiceTabDeTipo(TipoActor);
      end;
      ListasDeActoresTabs[indiceTab].Add(TActor(Sala.Dems[i]));
    end
  end;

  // Agrego los Generadores a los listados
  if Sala.Gens.Count > 0 then
  begin
    TipoActor := TActor(Sala.Gens[0]).ClassType;
    indiceTab := uInfoTabs.infoTabs.indiceTabDeTipo(TipoActor);
    for i := 0 to Sala.Gens.Count - 1 do
    begin
      if TipoActor <> TActor(Sala.Gens[i]).ClassType then
      begin
        TipoActor := TActor(Sala.Gens[i]).ClassType;
        indiceTab := uInfoTabs.infoTabs.indiceTabDeTipo(TipoActor);
      end;
      ListasDeActoresTabs[indiceTab].Add(TActor(Sala.Gens[i]));
    end
  end;

  // Agrego los Arcos a los listados
  if Sala.Arcs.Count > 0 then
  begin
    TipoActor := TActor(Sala.Arcs[0]).ClassType;
    indiceTab := uInfoTabs.infoTabs.indiceTabDeTipo(TipoActor);
    for i := 0 to Sala.Arcs.Count - 1 do
    begin
      if TipoActor <> TActor(Sala.Arcs[i]).ClassType then
      begin
        TipoActor := TActor(Sala.Arcs[i]).ClassType;
        indiceTab := uInfoTabs.infoTabs.indiceTabDeTipo(TipoActor);
      end;
      ListasDeActoresTabs[indiceTab].Add(TActor(Sala.Arcs[i]));
    end
  end;

  // Agrego los Contratos Energéticos a los listados
  if Sala.ComercioInternacional.Count > 0 then
  begin
    TipoActor := TActor(Sala.ComercioInternacional[0]).ClassType;
    indiceTab := uInfoTabs.infoTabs.indiceTabDeTipo(TipoActor);
    for i := 0 to Sala.ComercioInternacional.Count - 1 do
    begin
      if TipoActor <> TActor(Sala.ComercioInternacional[i]).ClassType then
      begin
        TipoActor := TActor(Sala.ComercioInternacional[i]).ClassType;
        indiceTab := uInfoTabs.infoTabs.indiceTabDeTipo(TipoActor);
      end;
      ListasDeActoresTabs[indiceTab].Add(TActor(Sala.ComercioInternacional[i]));
    end
  end;

  TCActoresChange(TCActores);
end;

procedure TFSimSEEEdit.guardar;
var
  f: TArchiTexto;
  dirTemporales: array [0 .. MAX_PATH] of Char;
begin
  // Saco el foco del control activo para que haga el onExit y guarde los cambios
  // si hace falta
  // Tengo que hacerlo así porque no permite hacer setFocus en controles invisibles
  // Si la pagina activa no es alguna de estas no importa porque no tienen controles
  // que necesiten perder el foco para guardar sus cambios
  if PCEditMain.ActivePage = TSGlobales then
    CBPostesMonotonos.SetFocus
  else if PCEditMain.ActivePage = TSEstado then
    CBEstabilizarFrameInicial.SetFocus
  else if PCEditMain.ActivePage = TSSimulador then
    CBObligar_Disp1.SetFocus;

  GetTempPath(MAX_PATH, @dirTemporales);
  f := TArchiTexto.CreateForWrite(dirTemporales + 'guardar_temp.ese', False, 0);
  try
    begin
      // Salvo en un archivo auxiliar para no corromper el original si hay problemas
      f.wr('sala', TSalaDeJuego(sala));
      f.Free;

      f := TArchiTexto.CreateForWrite(DSalvarSala.FileName,
        TSimSEEEditOptions.getInstance.guardarBackupDeArchivos,
        TSimSEEEditOptions.getInstance.maxNBackups);
      f.wr('sala', TSalaDeJuego(sala));
      guardado := True;
      DCargarSala.FileName := DSalvarSala.FileName;
      sala.setDirCorrida(DCargarSala.FileName);
    end
  finally
    f.Free;
  end;
end;

procedure TFSimSEEEdit.abrirMonitores;
var
  error: string;
begin
  if manejadorMonitores <> nil then
    LimpiarManejadorMonitores;

  try
    manejadorMonitores := TManejadoresDeMonitores.CargarManejadorDeMonitores
      (DCargarManejadorMonitores.FileName, false, sala);

    InitMonitores();
    DSalvarManejadorMonitores.FileName := DCargarManejadorMonitores.FileName;
  except
    on E: Exception do
      raise ;
  end;

  try
    manejadorMonitores.resolverReferenciasMonitores(TTodas);
  except
    on E: Exception do
    begin
      error := e.Message;

      while error <> '' do
        MemoWarnings.Lines.Add(NextStr(error));
    end;
  end;
  manejadorMonitores.limpiar;
end;

procedure TFSimSEEEdit.guardarMonitores;
var
  f: TArchiTexto;
  dirTemporales: array [0 .. MAX_PATH] of Char;
begin
  if ActiveControl is TEdit and assigned(TEdit(ActiveControl).onExit) then
    TEdit(ActiveControl).onExit(ActiveControl);

  GetTempPath(MAX_PATH, @dirTemporales);
  f := TArchiTexto.CreateForWrite(dirTemporales + 'guardarMonitores_temp.ese', False, 0);
  try
    begin
      // Guardo en un archivo auxiliar para no corromper el original si hay problemas
      f.wr('manejadorMonitores', manejadorMonitores);
      f.Free;

      f := TArchiTexto.CreateForWrite(DSalvarManejadorMonitores.FileName,
        TSimSEEEditOptions.getInstance.guardarBackupDeArchivos,
        TSimSEEEditOptions.getInstance.maxNBackups);
      f.wr('manejadorMonitores', manejadorMonitores);
      guardadoMonitores := True;
      DCargarManejadorMonitores.FileName := DSalvarManejadorMonitores.FileName;
    end
  finally
    f.Free;
  end;
end;

procedure TFSimSEEEdit.Init;
var
  nPostes, i: integer;
  DurPaso: Integer;
begin
  if sala <> nil then
  begin
    archiEditorSimRes3 := '';
    MGuardar.Enabled := true;
    MGuardarComo.Enabled := true;
    MHerramientas.Enabled := True;
    MMonitores.Enabled := true;
    TCActores.Visible := true;
    PCEditMain.Visible := true;

{$IFNDEF FPC}
      DTPFechaIniSim.DateTime := Sala.globs.fechaIniSim.AsDt;
      DTPFechaFinSim.DateTime := Sala.globs.fechaFinSim.AsDt;
      DTPFechaIniOpt.DateTime := Sala.globs.fechaIniOpt.AsDt;
      DTPFechaFinOpt.DateTime := Sala.globs.fechaFinOpt.AsDt;
{$ELSE}
      DTPFechaIniSim.Date := Sala.globs.fechaIniSim.AsDt;
      DTPFechaFinSim.Date := Sala.globs.fechaFinSim.AsDt;
      DTPFechaIniOpt.Date := Sala.globs.fechaIniOpt.AsDt;
      DTPFechaFinOpt.Date := Sala.globs.fechaFinOpt.AsDt;
{$ENDIF}

    nPostes := Sala.globs.NPostes;
    IntNPostes.Text := IntToStr(nPostes);
    sgPostes.ColCount := nPostes + 1;
    // utilidades.AutosizeTableWidth(gbPasoTiempo, sgPostes, gbPasoTiempo.ClientWidth);
    utilidades.AutosizeTableWidth(sgPostes);
    for i := 0 to nPostes - 1 do
    begin
      sgPostes.Cells[i + 1, 0] := IntToStr(i + 1);
      sgPostes.Cells[i + 1, 1] := FloatToStr(Sala.globs.DurPos[i]);
    end;
    CBPostesMonotonos.Checked := sala.globs.PostesMonotonos;

    utilidades.AutoSizeTable(TSGlobales, sgPostes, maxAnchoTablaEnorme,
      maxAlturaTablaChica,
      TSimSEEEditOptions.getInstance.deshabilitarScrollHorizontalEnListados);

    durPaso := 0;
    for i := 1 to nPostes do
      DurPaso := DurPaso + StrToInt(sgPostes.Cells[i, 1]);
    EDurPaso.Text := IntToStr(durPaso);
    recalcNumeroPasos(IntNPostes);

    // Tienen que ir debajo del calculo de EDurPaso.Text
    { DTPFechaIniSimChange(NIL);
      DTPFechaFinSimChange(NIL);
      DTPFechaIniOptChange(NIL);
      DTPFechaFinOptChange(NIL); }

    CBEstabilizarFrameInicial.Checked := sala.estabilizarInicio;
    if sala.usarArchivoParaInicializarFrameInicial then
    begin
      RGLlenarUltimoFrame.ItemIndex := 1;
      EArchivoCF.Enabled := True;
      BBuscarArchivoCF.Enabled := True;
      BEnganches.Enabled := True;
    end
    else
    begin
      RGLlenarUltimoFrame.ItemIndex := 0;
      EArchivoCF.Enabled := False;
      BBuscarArchivoCF.Enabled := False;
      BEnganches.Enabled := False;
    end;


    self.eArchiCFaux.text:= sala.archivoCFAux;

    if ( sala.engancharConSala ) then
    begin
      RBElegirSala.Checked := true;
      EArchivoCF.Text := sala.archivoSala_ParaEnganches;
    end
    else
    begin
      RBElegirCF.Checked:= true;
      EArchivoCF.Text := sala.archivoCF_ParaEnganches;
    end;

    ENCronicasSim.Text := IntToStr(Sala.globs.NCronicasSim);
    ENCronicasOpt.Text := IntToStr(Sala.globs.NCronicasOpt);
    CBSorteos.Checked := Sala.globs.SortearOpt;
    ENCronicasOpt.Enabled := CBSorteos.Checked;
    CBObligar_Disp1.Checked := Sala.globs.ObligarDisponibilidad_1_Sim;
    EtAct.Text := FloatToStrF(sala.globs.TasaDeActualizacion, ffGeneral, CF_PRECISION,
      CF_DECIMALES);
    eMaxNItersOpt.Text := IntToStr(sala.globs.NMAX_ITERACIONESDELPASO_OPT);
    eMaxNItersSim.Text := IntToStr(sala.globs.NMAX_ITERACIONESDELPASO_SIM);
{$IFNDEF ITERAR}
    lMaxNItersOpt.Visible := False;
    lMaxNItersSim.Visible := False;
    eMaxNItersOpt.Visible := False;
    eMaxNItersSim.Visible := False;

    gbVarOpt.Height := gbVarOpt.Height - eMaxNItersOpt.Height;
    gbVarSim_.Height := gbVarSim_.Height - eMaxNItersSim.Height;
{$ENDIF}

    MemoDesc.Clear;
    MemoDesc.Lines.DelimitedText := sala.descripcion;
    loQueHabia := MemoDesc.Lines.DelimitedText;

    guardado := True;
    Sala.PrepararseYPubliVars;

    manejadorMonitores.PrepararseYPubliVars;
    PCEditMainChange(Self);
    inicializarNuevoListadoActores;
  end
  else
  begin
    MGuardar.Enabled := false;
    MGuardarComo.Enabled := false;
    MHerramientas.Enabled := False;
    MMonitores.Enabled := false;
    TCActores.Visible := false;
    PCEditMain.Visible := false;
  end
end;

procedure TFSimSEEEdit.InitMonitores;
begin
  PCEditMainChange(Self);
  guardadoMonitores := True;
end;

{ function TFSimSEEEdit.prepararSala(fecha: TFecha ; paso, horasDelPaso: Integer): Integer;
  var
  pasoDeFecha: Integer;
  i: integer;
  begin
  if paso = 1 then
  begin
  sala.globs.Fijar_kPaso( paso );
  sala.Prepararse( true ); // Preparar para editar
  end;
  pasoDeFecha:= sala.globs.fechaToPaso(fecha);
  while (sala.globs.kPaso_ <= pasoDeFecha) do
  begin
  Sala.prepararSalaParaPaso;
  for i:= 0 to sala.Dems.Count -1 do
  TActor(sala.Dems[i]).PrepararPaso_ps;
  sala.globs.FechaInicioDelPaso.AddHoras( HorasDelPaso );
  inc( sala.globs.kPaso_ );
  end;
  result:= sala.globs.kPaso_;
  end;

  procedure TFSimSEEEdit.manejarExcepcionPrepararSala(e: Exception);
  begin
  ShowMessage('Se Encontro el Siguiente Error:' + #13 + e.Message + #13 + 'Resuelvalo para Poder Continuar.');
  end; }

function TFSimSEEEdit.validarFechasOptSim: boolean;
begin
  // fIniOpt <= fIniSim <= fFinSim <= fFinOpt
  if (DTPFechaIniOpt.Date <= DTPFechaIniSim.Date) and
    (DTPFechaIniSim.Date <= DTPFechaFinSim.Date) and
    (DTPFechaFinSim.Date <= DTPFechaFinOpt.Date) then
  begin
    Result := True;
  end
  else
  begin
    ShowMessage(mesHorizontesSimulacionNoValidos + #13#10 + mesSeDebeCumplirRelacionHorizontes);
    Result := False;
  end;
end;

function TFSimSEEEdit.validarFormulario: boolean;
begin
  result := validarFechasOptSim and inherited validarEditInt(IntNPostes, 1, MaxInt)
    and inherited validarEditInt(ENCronicasOpt, 1, MaxInt) and inherited validarEditFloat
    (EtAct, 0, MaxInt) and inherited validarEditInt(eMaxNItersOpt, 0, MaxInt)
    and inherited validarEditInt(TEdit(ENCronicasSim), 1, MaxInt)
    and inherited validarEditInt(eMaxNItersSim, 0, MaxInt);
end;

procedure TFSimSEEEdit.MAbrirClick(Sender: TObject);
var
  mbResult: integer;
begin
  if (not guardado) then
  begin
    mbResult := Application.MessageBox(
      pchar(mesSalaNoGuardadaGuardarCambios), PChar(mesSimSEEEdit),
      MB_YESNOCANCEL or MB_ICONEXCLAMATION);
    if mbResult = idYes then
    begin
      guardar;
      if self.DCargarSala.Execute then
        abrir;
    end
    else if mbResult = idNo then
      if self.DCargarSala.Execute then
        abrir;
  end
  else if self.DCargarSala.Execute then
    abrir
end;

procedure TFSimSEEEdit.MActualizarClick(Sender: TObject);
begin
  ChDir(getDir_Bin);
  ShellExecute(self.Handle, 'open', 'actualizador.exe', nil, nil, SW_SHOWNORMAL);
end;

procedure TFSimSEEEdit.MGuardarComoClick(Sender: TObject);
begin
  if self.DSalvarSala.Execute then
  begin
    DCargarSala.FileName := DSalvarSala.FileName;
    self.Caption := 'Editor - SimSEE - v' + uversiones.vSimSEEEdit + ' ( IIE-FING ) - ' +
      DCargarSala.FileName;
    guardar();
  end;
end;

procedure TFSimSEEEdit.MGuardarClick(Sender: TObject);
begin
  if DSalvarSala.FileName = '' then
    MGuardarComoClick(Sender)
  else
    guardar();
end;

procedure TFSimSEEEdit.MSalirClick(Sender: TObject);
begin
  self.Close;
end;

procedure TFSimSEEEdit.RBElegirCFChange(Sender: TObject);
begin
  if (RBElegirCF.Checked = true) then
  begin
    sala.engancharConSala := false;
    EArchivoCF.Text := sala.archivoCF_ParaEnganches;
  end;
  guardado := False;
end;

procedure TFSimSEEEdit.RBElegirSalaChange(Sender: TObject);
begin
  if (RBElegirSala.Checked = true)  then
  begin
    sala.engancharConSala := true;
    EArchivoCF.Text := sala.archivoSala_ParaEnganches;
  end;
  guardado := False;
end;

procedure TFSimSEEEdit.sgPostesKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  senderAsGrid: TStringGrid;
begin
  senderAsGrid := Sender as TStringGrid;
  validarSg := senderAsGrid.Cells[senderAsGrid.col, senderAsGrid.Row] <> loQueHabia;
  if (Key in teclas) then
    validarCambioTablaPostes(TStringGrid(Sender))
end;

procedure TFSimSEEEdit.sgPostesValidarCambio(Sender: TObject);
begin
  validarCambioTablaPostes(TStringGrid(Sender));
end;

procedure TFSimSEEEdit.sgMantenimientosGetEditText(Sender: TObject; ACol, ARow: Integer;
  var Value: string);
begin
  utilidades.listadoGetEditText(Sender, ACol, ARow, Value);
end;

procedure TFSimSEEEdit.TCActoresChange(Sender: TObject);
begin
  actualizarTablaActores;
end;

procedure TFSimSEEEdit.BAgregarActorClick(Sender: TObject);
begin
  altaActor(TCActores.Tabs[TCActores.tabindex]);
end;

procedure TFSimSEEEdit.sgActoresDrawCell(Sender: TObject; ACol, ARow: Integer; Rect: TRect;
  State: TGridDrawState);
begin
  utilidades.ListadoDrawCell(Sender, ACol, ARow, Rect, State, TiposColActores[ACol], NIL,
    iconos);
end;

procedure TFSimSEEEdit.sgActoresMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: integer);
begin
  utilidades.ListadoMouseDown(Sender, Button, Shift, X, Y);
end;

procedure TFSimSEEEdit.sgActoresMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: integer);
begin
  utilidades.ListadoMouseMove(Sender, Shift, X, Y, TiposColActores);
end;

procedure TFSimSEEEdit.sgActoresMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: integer);
var
  res: TTipoColumna;
begin
  res := utilidades.ListadoMouseUp(Sender, Button, Shift, X, Y, TiposColActores);
  case res of
    TC_btEditar:
      editarActor(
          TActor(ListasDeActoresTabs[TCActores.tabindex][utilidades.filaListado - 1])
        );
    TC_btEliminar:
      eliminarActor
        (TActor(ListasDeActoresTabs[TCActores.tabindex][utilidades.filaListado - 1]));
    TC_btClonar:
      clonarActor(TActor(ListasDeActoresTabs[TCActores.tabindex][utilidades.filaListado - 1])
        );
  end;
end;

procedure TFSimSEEEdit.EditNCronicasSimExit(Sender: TObject);
begin
  if validarEditInt(Sender as TEdit, 1, MAXINT) then
    sala.globs.NCronicasSim := StrToInt(TEdit(Sender).Text)
end;

procedure TFSimSEEEdit.BSimularClick(Sender: TObject);
var
  resultado: integer;
  aux: boolean;
  parametros, dondeEstaba: string;
begin
  aux := guardado;
  if validarFormulario then
  begin
    sala.globs.NCronicasOpt := StrToInt(ENCronicasOpt.Text);
    Sala.globs.TasaDeActualizacion := StrToFloat(EtAct.Text);
    sala.globs.NCronicasSim := StrToInt(ENCronicasSim.Text);
    sala.globs.abortarSim := false;

    guardado := aux;

    if not guardado then
    begin
      resultado := Application.MessageBox(
        pchar(mesGuardarCambiosSalaParaContinuar), PChar(mesSimSEEEdit), MB_YESNOCANCEL);
      if resultado = idYes then
        MGuardarComoClick(MGuardarComo)
      else if resultado = idCancel then
        exit;
    end;
    if not guardadoMonitores then
    begin
      resultado := Application.MessageBox(
        PChar(mesGuardarCambiosMonitoresParaContinuar), PChar(mesSimSEEEdit), MB_YESNOCANCEL);
      if resultado = idYes then
        MGuardarMonitoresComoClick(MGuardarMonitoresComo)
      else if resultado = idCancel then
        exit;
    end;
    if guardado and guardadoMonitores then
    begin
      getdir(3, dondeEstaba);
      ChDir(getDir_Bin);
      parametros := '"' + Self.DCargarSala.fileName + '" "' +
        self.DCargarManejadorMonitores.fileName + '"' + #0;
      ShellExecute(self.Handle, 'open', 'SimSEESimulador.exe', @parametros[1], NIL,
        SW_SHOWNORMAL);
      ChDir(dondeEstaba); //Despues quiero dejar la ubicacion en donde estaba trabajando antes
    end
  end
  else
    guardado := aux;
end;

procedure TFSimSEEEdit.FormCloseQuery(Sender: TObject; var CanClose: boolean);
var
  mbResult: integer;
begin
  if ActiveControl is TEdit and assigned(TEdit(ActiveControl).OnExit) then
    TEdit(ActiveControl).OnExit(ActiveControl)
  else if ActiveControl is TStringGrid and assigned(TStringGrid(ActiveControl).onExit) then
    TStringGrid(ActiveControl).OnExit(ActiveControl);
  if (not guardado) then
  begin
    mbResult := Application.MessageBox(
      PChar(mesSalaNoGuardadaGuardarCambios), PChar(mesSimSEEEdit),
      MB_YESNOCANCEL or MB_ICONEXCLAMATION);
    if mbResult = idYes then
    begin
      MGuardarClick(MGuardar);
      CanClose := guardado;
    end
    else if mbResult = idNo then
    begin
      CanClose := true
    end
    else
    begin
      CanClose := False;
    end
  end;
  if (not guardadoMonitores) then
  begin
    mbResult := Application.MessageBox(
      PChar(mesMonitoresNoGuardadosGuardarCambios), PChar(mesSimSEEEdit),
      MB_YESNOCANCEL or MB_ICONEXCLAMATION);
    if mbResult = idYes then
    begin
      MGuardarMonitoresClick(MGuardarMonitoresComo);
      CanClose := guardado;
    end
    else if mbResult = idNo then
    begin
      CanClose := true
    end
    else
    begin
      CanClose := False;
    end
  end;
  if CanClose then
    TSimSEEEditOptions.getInstance.guardar;
end;

procedure TFSimSEEEdit.sgMonitoresDrawCell(Sender: TObject; ACol, ARow: integer;
  Rect: TRect; State: TGridDrawState);
begin
  utilidades.ListadoDrawCell(Sender, ACol, ARow, Rect, State, TiposColMonitores[ACol], NIL,
    iconos);
end;

procedure TFSimSEEEdit.sgMonitoresMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  utilidades.ListadoMouseMove(Sender, Shift, X, Y, TiposColMonitores);
end;

procedure TFSimSEEEdit.sgMonitoresMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  utilidades.ListadoMouseDown(Sender, Button, Shift, X, Y);
end;

procedure TFSimSEEEdit.sgMonitoresMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: integer);
var
  res: TTipoColumna;
begin
  res := utilidades.ListadoMouseUp(Sender, Button, Shift, X, Y, TiposColMonitores);
  case res of
    TC_checkBox:
      begin
        if sgMonitores.Cells[utilidades.colListado, utilidades.filaListado] = '' then
          TReferenciaMonitor
            (manejadorMonitores.referenciasMonitores[utilidades.filaListado - 1])
            .Enabled := false
        else
          TReferenciaMonitor
            (manejadorMonitores.referenciasMonitores[utilidades.filaListado - 1])
            .Enabled := true;
      end;
    TC_btEditar:
      editarMonitor(utilidades.filaListado, false);
    TC_btEliminar:
      eliminarMonitor(utilidades.filaListado);
    TC_btClonar:
      editarMonitor(utilidades.filaListado, true);
  end;
end;

procedure TFSimSEEEdit.BAgregarFichaUnidadesClick(Sender: TObject);
begin
  altaMantenimiento;
end;

procedure TFSimSEEEdit.BAgregarMonitorClick(Sender: TObject);
begin
  altaMonitor
end;

procedure TFSimSEEEdit.BBuscarArchivoCFClick(Sender: TObject);
begin

  if (RBElegirCF.Checked = true) then
  begin
    ODCF.InitialDir := getDir_Run;
    ODCF.Filter := 'Archivos Binarios de Costos Futuros (*.bin)|*.bin|Todos los Archivos (*.*)|*.*';
  end
  else
  begin
    ODCF.InitialDir := getDir_Corridas;
    ODCF.Filter := 'Archivos SimSEEEdit (*.ese)|*.ese|Todos los Archivos (*.*)|*.*';
  end;

  if ODCF.Execute then
  begin
    EArchivoCF.Text := quitarRaiz(ODCF.FileName);
    EArchivoCFExit(BBuscarArchivoCF);
  end;
end;

procedure TFSimSEEEdit.BCrearMonitorSimRes3PDefectoClick(Sender: TObject);
begin
  crearMonitorSimResPorDefecto;
end;

procedure TFSimSEEEdit.recalcNumeroPasos(Sender: TObject);
begin
  Sala.globs.HorasDelPaso := StrToInt(EDurPaso.Text);
  ENPasosSim.Text := IntToStr(Sala.globs.calcNPasosSim);
  ENPasosOpt.Text := IntToStr(Sala.globs.calcNPasosOpt);
end;

procedure TFSimSEEEdit.MManualClick(Sender: TObject);
begin
  verdoc(self, 'editor-manualdeusuario', 'Manual de Usuario del Editor');
end;

procedure TFSimSEEEdit.CBSorteosClick(Sender: TObject);
begin
  guardado := False;
  ENCronicasOpt.Enabled := CBSorteos.Checked;
  LNCronicasOpt.Enabled := CBSorteos.Checked;
  Sala.globs.SortearOpt := CBSorteos.Checked;
end;

procedure TFSimSEEEdit.EtActExit(Sender: TObject);
begin
  if validarEditFloat(EtAct, 0, MAXINT) then
    Sala.globs.TasaDeActualizacion := StrToFloat(EtAct.Text);
end;

procedure TFSimSEEEdit.CBObligar_Disp1Click(Sender: TObject);
begin
  guardado := False;
  Sala.globs.ObligarDisponibilidad_1_Sim := CBObligar_Disp1.Checked;
end;

procedure TFSimSEEEdit.EditEnter(Sender: TObject);
begin
  inherited EditEnter(Sender);
end;

procedure TFSimSEEEdit.EditNCronicasOptExit(Sender: TObject);
begin
  if validarEditInt(TEdit(Sender), 1, MAXINT) then
    Sala.globs.NCronicasOpt := StrToInt(TEdit(Sender).Text);
end;

{ procedure TFSimSEEEdit.DTPFechaIniOptChange(Sender: TObject);
  begin
  Sala.globs.fechaIniOpt.dt:= DTPFechaIniOpt.Date;

  if DTPFechaIniOpt.Date > DTPFechaIniSim.date then
  begin
  DTPFechaIniSim.date:= DTPFechaIniOpt.Date;
  DTPFechaIniSimChange(Sender);
  end;

  Sala.globs.HorasDelPaso:= StrToInt(EDurPaso.Text);
  ENPasosOpt.Text:= IntToStr(Sala.globs.calcNPasosOpt);
  guardado:= false;
  end;

  procedure TFSimSEEEdit.DTPFechaIniSimChange(Sender: TObject);
  begin
  Sala.globs.fechaIniSim.dt:= DTPFechaIniSim.Date;

  if (DTPFechaIniOpt.Date > DTPFechaIniSim.Date) then
  begin
  DTPFechaIniOpt.Date:= DTPFechaIniSim.Date;
  DTPFechaIniOptChange(Sender);
  end
  else if (DTPFechaIniSim.Date >= DTPFechaFinSim.Date) then
  begin
  DTPFechaFinSim.Date:= DTPFechaIniSim.Date + 1;
  DTPFechaFinSimChange(Sender);
  end;

  Sala.globs.HorasDelPaso:= StrToInt(EDurPaso.Text);
  ENPasosSim.Text:= IntToStr(Sala.globs.calcNPasosSim);
  guardado:= false;
  end;

  procedure TFSimSEEEdit.DTPFechaFinSimChange(Sender: TObject);
  begin
  Sala.globs.fechaFinSim.dt:= DTPFechaFinSim.Date;

  if DTPFechaIniSim.Date >= DTPFechaFinSim.Date then
  begin
  DTPFechaIniSim.Date:= DTPFechaFinSim.Date - 1;
  DTPFechaIniSimChange(Sender);
  end
  else if DTPFechaFinSim.Date > DTPFechaFinOpt.Date then
  begin
  DTPFechaFinOpt.Date:= DTPFechaFinSim.Date;
  DTPFechaFinOptChange(Sender);
  end;

  Sala.globs.HorasDelPaso:= StrToInt(EDurPaso.Text);
  ENPasosSim.Text:= IntToStr(Sala.globs.calcNPasosSim);
  guardado:= false;
  end;

  procedure TFSimSEEEdit.DTPFechaFinOptChange(Sender: TObject);
  begin
  Sala.globs.fechaFinOpt.dt:= DTPFechaFinOpt.Date;

  if DTPFechaFinSim.Date > DTPFechaFinOpt.Date then
  begin
  DTPFechaFinSim.Date:= DTPFechaFinOpt.Date;
  DTPFechaFinSimChange(Sender);
  end;

  Sala.globs.HorasDelPaso:= StrToInt(EDurPaso.Text);
  ENPasosOpt.Text:= IntToStr(Sala.globs.calcNPasosOpt);
  guardado:= false;
  end; }

procedure TFSimSEEEdit.EArchivoCFExit(Sender: TObject);
var
  CF: TAdminEstados;
begin
  if loQueHabia <> EArchivoCF.Text then
  begin
    if FileExists(EArchivoCF.Text) { *Converted from FileExists*  } then
    begin
      if (RBElegirSala.Checked = true) then
      begin
        sala.archivoSala_ParaEnganches:= EArchivoCF.Text;
        sala.engancharConSala:= true;
      end
      else
      begin
        sala.archivoCF_ParaEnganches := EArchivoCF.Text;
        sala.engancharConSala:= false;
      end;

      guardado := False;

      if (RBElegirCF.Checked = true) then
      begin
        CF := TAdminEstados.CreateLoadFromArchi(EArchivoCF.Text);
        CF.Free;
      end;
    end
    else
      ShowMessage(mesElArchivo + EArchivoCF.Text + mesNoExiste);
  end;
end;


procedure TFSimSEEEdit.DTPEnter(Sender: TObject);
begin
{$IFNDEF FPC}
  loQueHabia := SysUtils.DateToStr(TDateTimePicker(Sender).Date);
{$ELSE}
  loQueHabia := SysUtils.DateToStr(TDateEdit(Sender).Date);
{$ENDIF}
end;

procedure TFSimSEEEdit.DTPFechaFinOptChange(Sender: TObject);
begin
  sala.globs.fechaFinOpt.dt := DTPFechaFinOpt.Date;
  Sala.globs.HorasDelPaso := StrToInt(EDurPaso.Text);
  ENPasosOpt.Text := IntToStr(Sala.globs.calcNPasosOpt);
  guardado := False;
end;

procedure TFSimSEEEdit.DTPFechaFinSimChange(Sender: TObject);
begin
  sala.globs.fechaFinSim.dt := DTPFechaFinSim.Date;
  Sala.globs.HorasDelPaso := StrToInt(EDurPaso.Text);
  ENPasosSim.Text := IntToStr(Sala.globs.calcNPasosSim);
  guardado := False;
end;

procedure TFSimSEEEdit.DTPFechaIniOptChange(Sender: TObject);
begin
  sala.globs.fechaIniOpt.dt := DTPFechaIniOpt.Date;
  Sala.globs.HorasDelPaso := StrToInt(EDurPaso.Text);
  ENPasosOpt.Text := IntToStr(Sala.globs.calcNPasosOpt);
  guardado := False;
end;

procedure TFSimSEEEdit.DTPFechaIniSimChange(Sender: TObject);
begin
  try
    sala.globs.fechaIniSim.dt := DTPFechaIniSim.Date;
    Sala.globs.HorasDelPaso := StrToInt(EDurPaso.Text);
    ENPasosSim.Text := IntToStr(Sala.globs.calcNPasosSim);
    guardado := False;
  except
    ENPasosSim.Text := 'error';
    guardado := False;
  end;
end;

procedure TFSimSEEEdit.MExportarClick(Sender: TObject);
var
  form: TFormExportar;
begin
  form := TFormExportar.Create(self, Sala.ListaActores, Sala.listaFuentes);
  if form.ShowModal = mrOk then
    cargarListados;
  form.Free;

end;

procedure TFSimSEEEdit.MImportarClick(Sender: TObject);
begin
  if DImportarActor.Execute then
    importar;
end;

procedure TFSimSEEEdit.PCEditMainChange(Sender: TObject);
var
  i: integer;
begin
  if PCEditMain.ActivePage = TSAyudaSolaperoPrincipal then
  begin
    verdoc(self, 'editor-solaperoPrincipal', '');
    PCEditMain.ActivePage := TSGlobales;
  end
  else if PCEditMain.ActivePage = TSActores then
    TCActoresChange(TCActores)
  else if PCEditMain.ActivePage = TSMonitores then
  begin
    sala.PrepararseYPubliVars;
    manejadorMonitores.PrepararseYPubliVars;
    actualizarTablaMonitores;
  end
  else if PCEditMain.ActivePage = TSMantenimientos then
  begin
    listaMantenimientos.Init(sala.Gens);
    for i := 0 to sala.ComercioInternacional.Count - 1 do
      if not(TComercioInternacional(sala.ComercioInternacional[i])
          is TContratoModalidadDevolucion) then
        listaMantenimientos.addActor(TComercioInternacional(sala.ComercioInternacional[i]));
    listaMantenimientos.sortByActorYFecha;
    BAgregarFichaUnidades.Enabled := sala.Gens.Count + sala.ComercioInternacional.Count > 0;
    actualizarTablaMantenimientos;
  end
  else if PCEditMain.ActivePage = TSFuentes then
  begin
    actualizarTablaFuentes;
  end else if PCEditMain.ActivePage = TSCombustible then
    actualizarTablaCombustibles;
end;

{ procedure TFSimSEEEdit.CBAnioMantenimientoChange(Sender: TObject);
  begin
  actualizarAnioTablaMantenimiento(StrToInt(CBAnioMantenimiento.Items[CBAnioMantenimiento.ItemIndex]));
  end; }

procedure TFSimSEEEdit.sgMantenimientosDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
begin
  utilidades.ListadoDrawCell(Sender, ACol, ARow, Rect, State, TiposColMantenimientos[ACol],
    NIL, iconos, validarCeldaMantenimientos);
end;

procedure TFSimSEEEdit.sgMantenimientosKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  utilidades.listadoKeyDown(Sender, Key, Shift, TiposColMantenimientos,
    Self.validarCeldaMantenimientos, self.cambioValorMantenimientos);
end;

procedure TFSimSEEEdit.sgMantenimientosMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  utilidades.ListadoMouseDown(Sender, Button, Shift, X, Y);
end;

procedure TFSimSEEEdit.sgMantenimientosMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  utilidades.ListadoMouseMove(Sender, Shift, X, Y, TiposColMantenimientos)
end;

procedure TFSimSEEEdit.sgMantenimientosMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  res: TTipoColumna;
  filaClon: integer;
begin
  res := utilidades.ListadoMouseUp(Sender, Button, Shift, X, Y, TiposColMantenimientos);
  case res of
    TC_btEditar:
      editarMantenimiento(TStringGrid(Sender).Row, false);
    TC_btEliminar:
      eliminarMantenimiento(TStringGrid(Sender).Row);
    TC_btClonar:
      begin
        filaClon := editarMantenimiento(TStringGrid(Sender).Row, true);
        if filaClon <> -1 then
          sgMantenimientos.Row := filaClon;
      end;
  end;
end;

procedure TFSimSEEEdit.sgMantenimientosValidarCambio(Sender: TObject);
begin
  utilidades.listadoValidarCambio(Sender, TiposColMantenimientos,
    Self.validarCeldaMantenimientos, self.cambioValorMantenimientos);
end;

procedure TFSimSEEEdit.CBEstabilizarFrameInicialClick(Sender: TObject);
begin
  sala.estabilizarInicio := CBEstabilizarFrameInicial.Checked;
  guardado := False;
end;

procedure TFSimSEEEdit.sgFuentesMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: integer);
begin
  utilidades.ListadoMouseDown(Sender, Button, Shift, X, Y);
end;

procedure TFSimSEEEdit.sgFuentesMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: integer);
begin
  utilidades.ListadoMouseMove(Sender, Shift, X, Y, TiposColFuentes);
end;

procedure TFSimSEEEdit.sgFuentesDrawCell(Sender: TObject; ACol, ARow: Integer; Rect: TRect;
  State: TGridDrawState);
begin
  utilidades.ListadoDrawCell(Sender, ACol, ARow, Rect, State, TiposColFuentes[ACol], NIL,
    iconos);
end;

procedure TFSimSEEEdit.sgFuentesMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: integer);
var
  res: TTipoColumna;
begin
  res := utilidades.ListadoMouseUp(Sender, Button, Shift, X, Y, tiposColFuentes);
  case res of
    TC_btEditar:
      editarFuente(TFuenteAleatoria(sala.listaFuentes[utilidades.filaListado - 1]));
    TC_btEliminar:
      eliminarFuente(TFuenteAleatoria(sala.listaFuentes[utilidades.filaListado - 1]));
    TC_btClonar:
      clonarFuente(TFuenteAleatoria(sala.listaFuentes[utilidades.filaListado - 1]));
  end;
end;



procedure TFSimSEEEdit.sgCombustibleMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: integer);
begin
  utilidades.ListadoMouseDown(Sender, Button, Shift, X, Y);
end;

procedure TFSimSEEEdit.sgCombustibleMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: integer);
begin
  utilidades.ListadoMouseMove(Sender, Shift, X, Y, TiposColCombustibles);
end;

procedure TFSimSEEEdit.sgCombustibleDrawCell(Sender: TObject; ACol, ARow: Integer; Rect: TRect;
  State: TGridDrawState);
begin
  utilidades.ListadoDrawCell(Sender, ACol, ARow, Rect, State, TiposColCombustibles[ACol], NIL,
    iconos);
end;

procedure TFSimSEEEdit.sgCombustibleMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: integer);
var
  res: TTipoColumna;
begin
  res := utilidades.ListadoMouseUp(Sender, Button, Shift, X, Y, TiposColCombustibles);
  case res of
    TC_btEditar:
      editarCombustible(TCombustible(sala.listaCombustibles[utilidades.filaListado - 1]));
    TC_btEliminar:
      eliminarCombustible(TCombustible(sala.listaCombustibles[utilidades.filaListado - 1]));
    TC_btClonar:
      clonarCombustible(TCombustible(sala.listaCombustibles[utilidades.filaListado - 1]));
  end;
end;

procedure TFSimSEEEdit.BAgregarFuenteClick(Sender: TObject);
begin
  altaFuente;
end;

procedure TFSimSEEEdit.BAgregarCombustibleClick(Sender: TObject);
begin
  altaCombustible;
end;

procedure TFSimSEEEdit.MCargarMonitoresClick(Sender: TObject);
var
  mbResult: integer;
begin
  if (not guardadoMonitores) then
  begin
    mbResult := Application.MessageBox(
      PChar(mesMonitoresNoGuardadosGuardarCambios), PChar(mesSimSEEEdit),
      MB_YESNOCANCEL or MB_ICONEXCLAMATION);
    if mbResult = idYes then
    begin
      guardarMonitores;
      if self.DCargarManejadorMonitores.Execute then
        abrirMonitores;
    end
    else if mbResult = idNo then
      if self.DCargarManejadorMonitores.Execute then
        abrirMonitores;
  end
  else if self.DCargarManejadorMonitores.Execute then
    abrirMonitores
end;

procedure TFSimSEEEdit.MCrearMonitorSimResPorDefectoClick(Sender: TObject);
begin
  crearMonitorSimResPorDefecto;
end;

procedure TFSimSEEEdit.MEditorSimRes3Click(Sender: TObject);
var
  resultado: integer;
  aux: boolean;
begin
  aux := guardado;
  if validarFormulario then
  begin
    sala.globs.NCronicasOpt := StrToInt(ENCronicasOpt.Text);
    Sala.globs.TasaDeActualizacion := StrToFloat(EtAct.Text);
    sala.globs.NCronicasSim := StrToInt(ENCronicasSim.Text);
    sala.globs.abortarSim := false;

    guardado := aux;

    if not guardado then
    begin
      resultado := Application.MessageBox(
        PChar(mesGuardarCambiosSalaParaContinuar), PChar(mesSimSEEEdit), MB_YESNOCANCEL);
      if resultado = idYes then
        MGuardarComoClick(MGuardarComo)
      else
        exit;
    end;

    editorSimRes3 := TEditorSimRes3.Create(self, sala, archiEditorSimRes3);
    if not editorSimRes3.errorAlCrear then
    begin
    editorSimRes3.ShowModal;
      if FileExists(editorSimRes3.sdArchiSimRes.FileName) then
      archiEditorSimRes3 := editorSimRes3.sdArchiSimRes.FileName;
    end;
    editorSimRes3.Free;
    editorSimRes3 := nil;
  end;
end;

procedure TFSimSEEEdit.MGuardarMonitoresClick(Sender: TObject);
begin
  if DSalvarManejadorMonitores.FileName = '' then
    MGuardarMonitoresComoClick(Sender)
  else
  begin
    guardarMonitores();
  end
end;

procedure TFSimSEEEdit.MGuardarMonitoresComoClick(Sender: TObject);
begin
  if DSalvarManejadorMonitores.FileName = '' then
    DSalvarManejadorMonitores.FileName := utilidades.titulo(DSalvarSala.FileName) + '.mon';
  if self.DSalvarManejadorMonitores.Execute then
  begin
    DCargarManejadorMonitores.FileName := DSalvarManejadorMonitores.FileName;
    guardarMonitores();
  end;
end;

procedure TFSimSEEEdit.miComponerCFsClick(Sender: TObject);
var
  formCompositor: TComponerCFs;
begin
  formCompositor := TComponerCFs.Create(Self);
  formCompositor.ShowModal;
  formCompositor.Free;
end;

procedure TFSimSEEEdit.BImportarClick(Sender: TObject);
begin
  if DImportarActor.Execute then
    importar;
end;

procedure TFSimSEEEdit.BEnganchesClick(Sender: TObject);
var
  form: TEditarEnganches;
begin
  if (EArchivoCF.Text <> '') and (FileExists(EArchivoCF.Text) and (RBElegirCF.Checked = true)) then
  begin
    form := TEditarEnganches.Create(self, EArchivoCF.Text, sala);
    if form.ShowModal = mrOk then
      guardado := False;
    form.Free;
  end
  else
    ShowMessage(mesSeleccionarArchivoBin);
end;

procedure TFSimSEEEdit.BExportarClick(Sender: TObject);
begin
  MExportarClick(MExportar);
end;

procedure TFSimSEEEdit.GenerarResumenTermico(Sender: TObject);
var
  archiRes: string;
begin
  archiRes := sala.generarResumenTermicoPrimerasFichas;
  if FileExists(archiRes) { *Converted from FileExists*  } then
  begin
    archiRes := archiRes + #0;
    ShellExecute(self.Handle, 'open', 'excel.exe', @archiRes[1], nil, SW_SHOWNORMAL);
  end;
end;

procedure TFSimSEEEdit.MOpcionesClick(Sender: TObject);
var
  form: TFormEditarOpciones;
  i: Integer;
  actor: TActor;
begin
  form := TFormEditarOpciones.Create(self);
  if form.ShowModal = mrOk then
  begin
    if not TSimSEEEditOptions.getInstance.fechasAutomaticas then
    begin
      for i := 0 to sala.listaActores.Count - 1 do
      begin
        actor := TActor(sala.listaActores[i]);
        if actor.nacimiento.dt = 0 then
          actor.nacimiento.PonerIgualA(minFecha(sala.globs.fechaIniSim,
              sala.globs.fechaIniOpt));
        if actor.muerte.dt = 0 then
          actor.muerte.PonerIgualA(maxFecha(sala.globs.fechaFinSim, sala.globs.fechaFinOpt));
      end;
    end
    else
    begin
      for i := 0 to sala.listaActores.Count - 1 do
      begin
        actor := TActor(sala.listaActores[i]);
        actor.nacimiento.dt := 0;
        actor.muerte.dt := 0;
      end;
    end;
    if PCEditMain.ActivePage = TSActores then
      actualizarTablaActores;
  end;
end;

procedure TFSimSEEEdit.CBPostesMonotonosClick(Sender: TObject);
begin
  sala.globs.PostesMonotonos := CBPostesMonotonos.Checked;
end;

procedure msgAdvertenciaCargandoDeArchivo(msg: string);
begin
  FSimSEEEdit.MemoWarnings.Lines.Add('Advertencia: ' + msg);
  // FSimSEEEdit.MemoWarnings.Visible:= true;
  // FSimSEEEdit.gbAdvertencias.Visible:= true;
end;

procedure msgErrorCargandoDeArchivo(msg: string);
begin
  FSimSEEEdit.MemoWarnings.Lines.Add(mesError + msg);
  FSimSEEEdit.nErroresCargando := FSimSEEEdit.nErroresCargando + 1;
end;

procedure TFSimSEEEdit.MemoDescEnter(Sender: TObject);
begin
  loQueHabia := MemoDesc.Lines.DelimitedText;
end;

procedure TFSimSEEEdit.MemoDescExit(Sender: TObject);
var
  AsString: string;
begin
  AsString := MemoDesc.Lines.DelimitedText;
  if loQueHabia <> AsString then
  begin
    sala.descripcion := AsString;
    guardado := False;
  end;
end;

procedure TFSimSEEEdit.btAyudaSimuladorClick(Sender: TObject);
begin
  verdoc(self, 'editor-optsim', '');
end;


procedure TFSimSEEEdit.btBuscarCFauxClick(Sender: TObject);
var
  CF: TAdminEstados;
  s: string;
begin
  ODCF.Filter := rsArchivosBinariosDeCostosFuturos + ' (*.bin)|*.bin|'+rsTodosLosArchivos+' (*.*)|*.*';
  if ODCF.Execute then
  begin
    guardado := False;
    s := trim(quitarRaiz(ODCF.FileName));
    if s <> eArchiCFaux.Text then
      eArchiCFAux.Text := s;
    if eArchiCFAux.Text <> '' then
      if FileExists(eArchiCFAux.Text) then
      begin
        sala.archivoCFAux := EArchiCFaux.Text;
        CF := TAdminEstados.CreateLoadFromArchi(EArchiCFAux.Text);
        CF.Free;
      end
      else
        ShowMessage(mesElArchivo + EArchiCFAux.Text + mesNoExiste);
  end;
end;

procedure TFSimSEEEdit.Button1Click(Sender: TObject);
begin
  verdoc(self, 'editor-cfaux', 'Función de Costo Futuro Auxiliar');
end;

procedure TFSimSEEEdit.btAyudaGlobalesClick(Sender: TObject);
begin
  verdoc(self, 'editor-variablesglobales', 'Variables Globales');
end;

procedure TFSimSEEEdit.btAyudaFuentesClick(Sender: TObject);
begin
  verdoc(self, 'editor-fuentesaleatorias', 'Fuentes Aleatorias');
end;

procedure TFSimSEEEdit.btAyudaActores_listaespecificaClick(Sender: TObject);
begin
  verdoc(self, 'editor-' + hid_ActoresListaEspecifica, '');
end;

procedure TFSimSEEEdit.btAyudaMantenimientosClick(Sender: TObject);
begin
  verdoc(self, 'editor-mantenimientos', 'Mantenimientos');
end;

procedure TFSimSEEEdit.btAyudaEstadosClick(Sender: TObject);
begin
  verdoc(self, 'editor-estados', 'Estados');
end;

procedure TFSimSEEEdit.btAyudaMonitoresClick(Sender: TObject);
begin
  verdoc(self, 'editor-monitores', 'Monitores');
end;

procedure TFSimSEEEdit.ODO1Click(Sender: TObject);
begin
  verdoc(self, 'editor-todo', 'PorHacer');
end;

end.

