unit utestvisortabla;

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

interface

uses
{$IFDEF FPC-LCL}
        LResources,
{$ENDIF}
  Windows, Messages, SysUtils, Variants, Classes,
  Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls,
  uvisordetabla, Buttons,
  uStringGridWithControls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Panel1: TPanel;
    ScrollBox2: TScrollBox;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
    x, y: integer;
    nid: integer;
  end;

var
  Form1: TForm1;

implementation
{$IFNDEF FPC-LCL}
{$R *.dfm}
{$ENDIF}

procedure TForm1.FormCreate(Sender: TObject);
begin
    x:= 10;
    y:= 10;
    nid:= 1;
end;



procedure TForm1.Button2Click(Sender: TObject);
var
  miTabla: TTabla;
  k, j: Integer;
begin
  mitabla:= TTabla.Create(scrollbox2, 'TablaTest', 4, 0, 0);


  mitabla.ClearRedim( 12, 10 );

// fila encabezado
  for j:= 0 to 4 do
  begin
    mitabla.wrTexto('', 0, j, 'Campo'+IntToStr(j) );
    mitabla.GetCelda(0, j).Color:= clGray;
    mitabla.AlinearCelda(0,j, CAH_Centro, CAV_Abajo );
  end;

  for k:= 1 to 9 do
  begin
    for j:= 0 to 2 do
      mitabla.wrTexto('', k, j,  'Celda('+IntToStr(k)+','+IntToStr(j)+')' );

    mitabla.wrEdit( 'e_'+IntToStr(k), k, 3, 'hola'+IntToStr(k), (1+k)*2, '');

    mitabla.wrCheckBox( 'cb_'+IntToStr(k), k, 4, false,'Marcar' );
    mitabla.wrBitBtn('bt_Editar'+IntToStr(k), k,5, iid_Editar, 'Editar');
    mitabla.wrBitBtn('bt_Borrar'+IntToStr(k), k,5, iid_Borrar, 'Eliminar');
    mitabla.wrBotonera( IntToStr(k), k, 6, [0,1,2,3,4,5,6,7,8,9,10,11,12], []);
  end;

  mitabla.AlinearColumna(3, CAH_Centro, CAV_Centro);

  mitabla.reposicionar;
  mitabla.Parent:= scrollbox2;
//  scrollbox2.InsertControl( mitabla );
//  mitabla.Visible:= true;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  sgwc: TStringGridWithControls;
  i,j: Integer;

begin

  sgwc:= TStringGridWithControls.Create(Panel1, 'test');
  sgwc.ImageList:=DataModule2.ImageList1;
  sgwc.SetEncabezados(['Col0', 'Col1', 'Col2', 'Col3', 'Col4', 'Col5'],
    [TC_Texto, TC_Texto,TC_Texto, TC_BitBtn, TC_BitBtns, TC_CheckBox]);

 // mitabla.GetCelda(0, j).Color:= clGray;
 // mitabla.AlinearCelda(0,j, CAH_Centro, CAV_Abajo );

  for i:= 1 to 25 do
  begin

    sgwc.RowCount:=sgwc.RowCount+1;
    for j:= 0 to 2 do
      sgwc.wrText(j, i,  'Celda((( '+IntToStr(i)+','+IntToStr(j)+' ))))' );

    sgwc.wrBitBtns(j+1, i, [iid_Borrar], []);
    sgwc.wrBitBtns(j+2, i, [iid_Lupa, iid_Editar, iid_Borrar], []);
    sgwc.wrCheckBox(j+3, i, false, 'Marcar' );

  end;

  sgwc.AutoSizeColumns;

  sgwc.Width:=Panel1.Width-50;
  sgwc.Height:=Panel1.Height-50;

//  mitabla.AlinearColumna(3, CAH_Centro, CAV_Centro);

end;

initialization
{$IFDEF FPC-LCL}
  {$I utestvisortabla.lrs}
{$ENDIF}
end.
