UNIT raton;

INTERFACE
   uses Controls, Graphics, horrores;


 VAR
	raton_x, raton_y: integer;
	raton_boton_derecho, raton_boton_izquierdo, raton_boton_centro: boolean;

 {..Del Ratn..}                  ContBoton: Integer;
 (*
 {....Otras....}                        x,y: Word;
					  Izquierda, Derecha, Centro: Boolean;
									  xx, i, c, graf: integer;

						{..Procedimientos Relativos al ratn.....}
  *)



PROCEDURE RESET_RATON;
PROCEDURE PUNTERO_A_XY(x, y:Word);
PROCEDURE LEER_RATON(var x, y:Word; var izquierda, centro, derecha:Boolean);
PROCEDURE SOLTAR_RATON(x,y:Word; izquierda, centro, derecha:Boolean);
PROCEDURE RANGO_COLUMNA(sup, inf:Word);
PROCEDURE RANGO_FILA(sup, inf:Word);
PROCEDURE INICIALIZAR_RATON;
FUNCTION  RATON_INSTALADO:Boolean;

{PROCEDURE LLAMA_RATON( var  M1, M2, M3, M4 :Word);}

IMPLEMENTATION

{**********************************************************************}

 VAR      M1, M2, M3, M4:Word;







{**********************************************************************}
{.........................RELATIVOS AL RATON...........................}
{**********************************************************************}

PROCEDURE LLAMA_RATON( var  M1, M2, M3, M4 :Word);

begin
end;

{-----------------------------------------------------------------------}

FUNCTION NUMERO_DE_BOTONES:Integer;
begin
NUMERO_DE_BOTONES:=2;
end;

{-----------------------------------------------------------------------}

FUNCTION RATON_INSTALADO:Boolean;
begin
   result:= mouse.MousePresent;
end;

{-----------------------------------------------------------------------}
    {...Los procedimientos por encima de este punto son privados...}

PROCEDURE RESET_RATON;
begin
   M1:=0;
   LLAMA_RATON(M1, M2, M3, M4);

   raton_x:= mouse.CursorPos.x;
   raton_y:= mouse.CursorPos.y;

   raton_boton_derecho:= false;
   raton_boton_izquierdo:= false;
   raton_boton_centro:= false;
end;


{-----------------------------------------------------------------------}

PROCEDURE LEER_RATON(var x, y:Word; var izquierda, centro, derecha:Boolean);
begin

   x:= raton_x;
   y:= raton_y;

   izquierda:= raton_boton_izquierdo;
   derecha:= raton_boton_derecho;
   centro:= raton_boton_centro;
end;

{-----------------------------------------------------------------------}

PROCEDURE PUNTERO_A_XY(x, y:Word);
begin
   
M1:=4;
M3:=x;
M4:=y;
LLAMA_RATON(M1, M2, M3, M4);
end;

{-----------------------------------------------------------------------}

PROCEDURE RANGO_COLUMNA(sup, inf:Word);
begin
M1:=7;
M3:=inf;
M4:=sup;
LLAMA_RATON(M1, M2, M3, M4);
end;

{-----------------------------------------------------------------------}

PROCEDURE RANGO_FILA(sup, inf:Word);
begin
M1:=8;
M3:=inf;
M4:=sup;
LLAMA_RATON(M1, M2, M3, M4);
end;

{-----------------------------------------------------------------------}

PROCEDURE SOLTAR_RATON(x,y:Word; izquierda, centro, derecha:Boolean);
begin
Repeat LEER_RATON(x,y, izquierda, centro, derecha);
until (izquierda=FALSE) AND (derecha=FALSE);
end;

{-----------------------------------------------------------------------}

PROCEDURE ESPERAR_A_RATON_DERECHO(x,y:Word; izquierda, centro, derecha:Boolean);
  var  concluir:Boolean;
begin
concluir:=FALSE;
derecha:=FALSE;
  while concluir=FALSE do
  begin
  LEER_RATON(x,y, izquierda, centro, derecha);
	if derecha=TRUE then concluir:=TRUE;
  end;
SOLTAR_RATON(x,y, izquierda, centro, derecha);
end;

{----------------------------------------------------------------------}

PROCEDURE INICIALIZAR_RATON;
BEGIN
			 {..Comprobacin del Ratn..}

	 IF NOT RATON_INSTALADO then
	 begin
	 error('ERROR: No se detecta controlador de RATON. Volver al DOS.');
	 end;
{ContBoton:=NUMERO_DE_BOTONES;
						{...COMIENZO CON RATON...}
{
Derecha:=FALSE;
Centro:=FALSE;}
RANGO_FILA(7,473);
RANGO_COLUMNA(490,632);
PUNTERO_A_XY(610,447);
END;

{-----------------------------------------------------------------------}
{...........................INICIALIZAR.................................}

BEGIN
 ContBoton:=Numero_De_Botones; {..Inicialicacin referente al Ratn..}
END.


